<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/mime.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/export.php";
include_once "include/orderby.php";

$compress_pages = false;   /* Explicitly disable it here */

$database = site_prolog(PO_USER_TYPE_USER);

$export_type       = $_REQUEST['export_type'];
$export_format     = $po_options['export_format'];

$photos_in_spooler = pg_query($database, "
  select photo as identifier from album_content where album = $po_user[spool_album] group by photo order by photo");

$num_photos = pg_num_rows($photos_in_spooler);

site_header($strings['generic']['export']);
site_navigator(5);
site_navigator_status("", $strings['spool']['photos_in'] .": $num_photos");

print "<div align=\"left\">";
print "<p>".sprintf($strings['export']['exporting'], "<strong>$num_photos</strong>")."</p>\n";

$temporary_directory = tempnam($tmp_volume_path, "po.export.");
unlink($temporary_directory);

$export_id = basename($temporary_directory);
$export_id = substr($export_id, strlen("po.export."));

print "<ul>";
print "<li>" . sprintf($strings['import']['creating_temp_dir']);
$old_mask = umask(0000);
if (!mkdir($temporary_directory)) {
  print err_str(" - $temporary_directory - ". $strings['generic']['failed']);
} 
print "</li>";

switch($export_type) {
 case "photo":
 case "photo_xml_iptc":
 case "photo_iptc":
 default:
   break;
 case "photo_xml":
   print "<li>".$strings['export']['create_xml'];
   if (($xml_file_desciptor = fopen ($temporary_directory."/data.xml", "w+")) == FALSE) {
     print err_str($strings['generic']['failed']);
   }
   print "</li>";

   fwrite($xml_file_desciptor, create_xml_header());
   fwrite($xml_file_desciptor, create_xml_bulkupload_header());
   break;
}

switch ($export_format) {
 case 'tar':
   /* creates the tar archive */
   $exp_file_name = $temporary_directory . ".tar";
   break;
 case 'zip' :
   chdir($temporary_directory);
   $exp_file_name = $temporary_directory . ".zip";
   break;
 } 

for ($photos = 0; $photos < $num_photos; $photos++) {
  $photo_identifier = pg_fetch_assoc($photos_in_spooler, $photos);

  /* optimize query, by excluding fields that are not used when not exporting shooting data */
  switch($export_type) {
  case "photo_xml_iptc":
  case "photo_iptc":
  case "photo_xml":
    $photo_data = pg_fetch_row(pg_query($database, "
       select folder, author, title, '' as keyword, caption, copyright_statement, date_of_exposure,
              location, storage_location, storage_index,
              access_rights, hide_original,
              camera, lens, filter, film, flash, scanner, focal_length, aperture, shutter,
              exposure_comp, ev_difference, camera_metering, camera_program, flash_mode, flash_comp,
              scan_resolution, scan_bitdepth, scan_multiscan, iso_override, support,
              latitude, longitude, altitude, img_direction, users, can_access_photo(photo.identifier, $po_user[id], '{".$passwords."}'),
              store_url, photo.comments
         from photo, photo_version, photo_tech, photo_dupe
        where photo.identifier = photo_version.photo
          and photo.identifier = photo_dupe.photo
          and photo.identifier = photo_tech.photo
          and photo.identifier = $photo_identifier[identifier]
          and photo_dupe.key = 1"));


    /* If we can't access the original or access the image... */
    if (($photo_data[36] != $po_user['id']) &&
	!($po_user['type'] == PO_USER_TYPE_ADMIN)) {
      if (($photo_data[37] != 't') || ($photo_data[11] != 't')) {
	continue 2;
      }
    }
    
    /* Get any keywords for the photo... */
    $res = pg_query($database, "select keyword from photo_keywords where photo=$photo_identifier[identifier]");
    $keywords = FALSE;
    for ($i=0; $i < pg_num_rows($res); $i++) {
      $dat = pg_fetch_assoc($res);
      $keywords[$i] = $dat['keyword'];
    }

    break;
  case "photo":
  default:
    $photo_data = pg_fetch_row(pg_query($database, "select users, hide_original, title, can_access_photo(photo.identifier, $po_user[id], '{".$passwords."}') from photo where identifier = $photo_identifier[identifier]"));
    /* Make sure we can access it! */
    if (($photo_data[0] != $po_user['id']) &&
	!($po_user['type'] == PO_USER_TYPE_ADMIN)) {
      if (($photo_data[3] != 't') || ($photo_data[1] != 't')) {
	continue 2;
      }
    }
    break;
  }

  $photo_version_data = pg_query($database, "
     select get_image_path(photo_version.identifier, 0) as original_path, original_image_name, comment, master
       from photo_version
      where photo_version.photo = $photo_identifier[identifier]");

  $title = $photo_data[2];
  if ($title == "")
    $title = $strings['photo']['no_title'] ." - $photo_identifier[identifier]";

  print "<li>" . $strings['export']['image'] . ($photos + 1) . "/$num_photos - <a href=\"photo.php?photo=$photo_identifier[identifier]\">$title</a>.";

  /* Generate filename list */
  for ($versions = 0; $versions < pg_num_rows($photo_version_data); $versions++) {
    $photo_version_single = pg_fetch_row($photo_version_data, $versions);

    $file_name = $image_repository_path."/".$photo_version_single[0];
    $original_name = $temporary_directory."/".$photo_version_single[1];

    print "<ul>";

    /* check for the source file's existence */
    if (!is_file($file_name)) {
      print "<li>". err_str($strings['errors']['file_not_found']) ." : ". sprintf($strings['export']['skipped'], "<a href=\"photo.php?photo=$photo_identifier[identifier]\">$title</a>") . "</li>";
      print "</ul>";
      continue;
    }

    /* Symlink to the original file using the proper name */
    $original_name = $temporary_directory."/".$photo_version_single[1];

    print "<li>".sprintf($strings['export']['adding'], $photo_version_single[1]);
    exec("ln -s \"$file_name\" \"$original_name\"", $who_cares, $retval_tar);
    
    /* we use "exec" instead of "system" to avoid unwanted output */
    if ($retval_tar) {
      print err_str($strings['generic']['failed']);
      print "</li>";
    } else {
      print "</li>";
    }
    print "</ul>";
  }
  print "</li>";

  /* export shooting data */
  switch($export_type) {
  case "photo":
  default:
    break;
  case "photo_xml":
    $image_data = array ("file" => array(0 => array("name" => "", "remark" => "", "master" => "")),
                         "folder"                => $photo_data[0],
                         "author"                => $photo_data[1],
                         "title"                 => $photo_data[2],
                         "keywords"              => $keywords,
                         "caption"               => $photo_data[4],
                         "copyright"             => $photo_data[5],
                         "date_of_exposure"      => $photo_data[6],
                         "location"              => $photo_data[7],
                         "storage_location_type" => $photo_data[8],
                         "storage_location_id"   => $photo_data[8],
                         "storage_index"         => $photo_data[9],
                         "access_rights"         => $photo_data[10],
                         "hide_original"         => $photo_data[11],
                         "camera"                => $photo_data[12],
                         "lens"                  => $photo_data[13],
                         "filter"                => $photo_data[14],
                         "film"                  => $photo_data[15],
                         "flash"                 => $photo_data[16],
                         "scanner"               => $photo_data[17],
                         "focal_length"          => $photo_data[18],
                         "aperture"              => $photo_data[19],
                         "shutter"               => $photo_data[20],
                         "exp_comp"              => $photo_data[21],
                         "exp_diff"              => $photo_data[22],
                         "camera_metering"       => $photo_data[23],
                         "camera_program"        => $photo_data[24],
                         "flash_mode"            => $photo_data[25],
                         "flash_comp"            => $photo_data[26],
                         "scan_resolution"       => $photo_data[27],
                         "scan_bitdepth"         => $photo_data[28],
                         "scan_multiscan"        => $photo_data[29],
                         "iso_override"          => $photo_data[30],
                         "support"               => $photo_data[31],
                         "latitude"              => $photo_data[32],
                         "longitude"             => $photo_data[33],
                         "altitude"              => $photo_data[34],
                         "direction"             => $photo_data[35],
			 "store_url"             => $photo_data[38],
			 "remark"                => $photo_data[39]);

    for ($versions = 0; $versions < pg_num_rows($photo_version_data); $versions++) {
      $photo_version_single = pg_fetch_row($photo_version_data, $versions);
      $image_data['file'][$versions]['name']   = $photo_version_single[1];
      $image_data['file'][$versions]['remark'] = $photo_version_single[2];
      $image_data['file'][$versions]['master'] = $photo_version_single[3];
    }

    fwrite($xml_file_desciptor, create_xml_folder_header($image_data['folder']));
    fwrite($xml_file_desciptor, create_xml_photo($image_data));
    fwrite($xml_file_desciptor, create_xml_folder_footer());
    print "<li>".$strings['export']['append_xml']."</li>";
    break;
  case "photo_xml_iptc":
  case "photo_iptc":
    print "<li>".err_str($strings['errors']['iptc_not_implemented'])."</li>";
  }

  flush();

 }

switch($export_type) {
 case 'photo':
 case 'photo_iptc':
 case 'photo_xml_iptc':
 default:
   break;
 case 'photo_xml':
   print "<li>".$strings['export']['close_xml']."</li>";
   fwrite($xml_file_desciptor, create_xml_bulkupload_footer());
   fclose($xml_file_desciptor);

   print "<li>".sprintf($strings['export']['adding'], $photo_version_single[1]) ."</li>";
   break;
}

print "<li>".$strings['export']['creating_archive']. "...";

/* Create the acual archive from symlink list */
switch ($export_format) {
 case 'tar':
   $command = $sys_tar." -cf \"$exp_file_name\" -h -C \"$temporary_directory\" . ";
   /* from now on, append to the tar archive */
   break;
 case 'zip':
   $command = $sys_zip." -D -r -0 \"$exp_file_name\" . ";
   break;
 } 

/* we use "exec" instead of "system" to avoid unwanted output */
exec($command, $who_cares, $retval_tar);
if ($retval_tar) {
  print err_str($strings['generic']['failed']);
  print "</li>";
  return false;
 } else {
  print "</li>";
 }


print "<li>".sprintf($strings['import']['removing_temp_dir']);
if (!deltree($temporary_directory)) {
  print err_str(" - $temporary_directory - " . $strings['generic']['failed']);
}
print "</li>";

print "</ul>\n";

umask($old_mask);
print "<h3>".$strings['export']['finished']."</h3>";

print sprintf($strings['export']['download'], "<a href=\"export.2.php?export_id=$export_id&amp;export_format=$export_format\">".$strings['generic']['here']."</a>");

print "</div>\n";

site_footer($database);
site_epilog($database);
?>
