<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
;
include_once "include/common.php";

$type = 'film';

$database = site_prolog(PO_USER_TYPE_USER);

$manufacturer_filter = pg_escape_string(isset($_REQUEST['filter']) ? $_REQUEST['filter'] : "");
$manufacturer = pg_query($database, "select identifier, name from manufacturer order by name");

switch ($manufacturer_filter) {
 case 'All':
 case '':
   $all_film_types = pg_query($database, "select identifier, name, model, iso, format, url from view_film_type order by name");
   break;
 default:
   $all_film_types = pg_query($database, "select identifier, name, model, iso, format, url from view_film_type where view_film_type.name='$manufacturer_filter' order by name");
}

site_header(sprintf($strings['profile']['add'], $strings['generic'][$type]));
site_navigator(6);
site_navigator_status(emit_a("user.php", $strings['generic']['users'])." : ".emit_a("my.profile.php", $strings['generic']['my_profile'])." : ".sprintf($strings['profile']['add'], $strings['generic'][$type]), "");

theme_display_navigator_box_top($profile_data['film']['idx'], $profile_data, "100%");

if (pg_num_rows($manufacturer) == 0) {
  print emit_manuf_add_needed($type);
  theme_display_navigator_box_bottom("100%");
  site_footer($database);
  site_epilog($database);
  exit;
}

print "<form method=\"post\" action=\"film.add.2.php\">\n";
print "<table class=\"profile\">\n";

emit_profile_manuf_combo("film.add.php?type=$film", $type, 4, $manufacturer, $manufacturer_filter);

print "<tr>\n";
print "<th width=\"4%\"></th>\n";
print emit_th($strings['profile']['manufacturer']);
print emit_th($strings['profile']['model']);
print emit_th($strings['profile']['iso']);
print emit_th($strings['profile']['format']);
print "</tr>\n";

$num_of_film_types = pg_num_rows($all_film_types);
if ($num_of_film_types > 0) {
  for ($i=0; $i < $num_of_film_types; $i++) {
    $film_type = pg_fetch_row($all_film_types, $i);
    print "<tr>\n";
    print "<td><input type=\"radio\" name=\"film_type_id\" value=\"$film_type[0]\" /></td>\n";
    print "<td><a href=\"$film_type[5]\">$film_type[1]</a></td>\n";
    print "<td>$film_type[2]</td>\n";
    print "<td>$film_type[3]</td>\n";
    print "<td>$film_type[4]</td>\n";
    print "</tr>\n";
  }
 } else {
  print "<tr><td colspan=\"5\">".sprintf($strings['profile']['none_found'], $strings['generic'][$type])." ".$strings['generic']['types'] ."</td></tr>\n";
 }
print "</table>\n";

print "<table class=\"profile\">\n";
print "<tr class=\"folder_top\">\n";
print emit_td($strings['generic']['add']." ".$strings['generic'][$type], 'colspan="5"');
print "</tr>\n";
print "<tr>\n";
print "<th width=\"4%\"></th>\n";
print emit_th($strings['profile']['manufacturer'], "width=\"20%\"");
print emit_th($strings['profile']['model'], "width=\"20%\"");
print emit_th($strings['profile']['iso']);
print emit_th($strings['profile']['format']);
print "</tr>\n";

print "<tr>\n";
print "<td><input type=\"radio\" name=\"film_type_id\" value=\"custom\" checked=\"checked\" /></td>\n";
print "<td>\n";
print emit_manufacturer_combo('film_manufacturer_id', $manufacturer, "");
print "</td>\n";
print "<td><input type=\"text\" name=\"film_model\" /></td>\n";
print "<td>\n";
$all_film_iso = pg_query($database, "select identifier, value from film_iso order by value");
$num_of_film_iso = pg_num_rows($all_film_iso);
print "<select name=\"film_iso\">";
for ($i=0; $i < $num_of_film_iso; $i++) {
  $film_iso = pg_fetch_row($all_film_iso, $i);
  print emit_option("$film_iso[0]", $film_iso[1], FALSE);
}
print "</select>";
print "</td>\n";
print "<td><select name=\"film_format_id\">\n";
$all_film_format = pg_query($database, "select identifier, value from film_format");
$num_of_film_formats = pg_num_rows($all_film_format);
for ($i=0; $i < $num_of_film_formats; $i++) {
  $film_format = pg_fetch_row($all_film_format, $i);
  print emit_option("$film_format[0]", $film_format[1], FALSE);
}
print "</select></td>\n";
print "</tr>\n";
print "</table>\n";

print "<table class=\"profile\">\n";
print "<tr class=\"folder_top\"><td colspan=\"5\">".sprintf($strings['profile']['specific_data'], $strings['generic'][$type])."</td></tr>\n";

print "<tr>\n";
print emit_th($strings['generic']['access']);
print "</tr>\n";

print "<tr>\n";
print "<td>\n"; display_access_combo("film_access_rights", "t", ""); print "</td>\n";
print "</tr>\n";
print "</table>\n";

print $thm_elem['button.add'];
print $thm_elem['button.clear'];
print $thm_elem['button.cancel'];
print "</form>\n";

theme_display_navigator_box_bottom("100%");

site_footer($database);
site_epilog($database);
?>
