<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/search.2.php";

include_once "include/site.php";

$return_path = isset($_REQUEST['return']) ? $_REQUEST['return'] : "";

$database = site_prolog();

$owner_id = isset($_REQUEST['user']) ? $_REQUEST['user'] : 0;

$destination_folder = pg_escape_string(isset($_REQUEST['destination_folder']) ? $_REQUEST['destination_folder'] : "");
$destination_album  = pg_escape_string(isset($_REQUEST['destination_album'])? $_REQUEST['destination_album'] : "");
$source_folder      = pg_escape_string(isset($_REQUEST['source_folder']) ? $_REQUEST['source_folder'] : "");
$source_album       = pg_escape_string(isset($_REQUEST['source_album']) ? $_REQUEST['source_album'] : "");

$goto_f_request     = isset($_REQUEST['go_to_f']);
$goto_a_request     = isset($_REQUEST['go_to_a']);
$move_f_request     = isset($_REQUEST['move_to_f']);
$link_a_request     = isset($_REQUEST['link_to_a']);
$move_a_request     = isset($_REQUEST['move_to_a']);

$print_request       = isset($_REQUEST['print_req']);
$spool_request       = isset($_REQUEST['spool_req']);
$export_request      = isset($_REQUEST['export_req']);
$bulk_update_request = isset($_REQUEST['bulk_update_req']);
$delete_request      = isset($_REQUEST['delete_req']);
$add_photo_request   = isset($_REQUEST['add_photos']);
$empty_trash_request = isset($_REQUEST['empty_trash_req']);

if (isset($_REQUEST['selection']) && is_array($_REQUEST['selection'])) {
  foreach ($_REQUEST['selection'] as $photo) {
    $parts = explode(":", $photo);
    $photo_data[] = $parts[0];
    $version_data[] = $parts[1];
  }
  $photos = implode(",", $photo_data);
  $versions = implode(",", $version_data);
} else {
  $photos = "";
  $versions = "";
}

/* Doesn't take arguments */
if ($export_request) {
  site_epilog($database);
  header("Location: export.php?export_type=$_REQUEST[export_type]");
  exit();
}

/* Doesn't take arguments */
if ($print_request != "") {
  site_epilog($database);
  header("Location: print.php?print_type=$_REQUEST[print_type]");
  exit();
}

if ($add_photo_request) {
  header("Location: photo.add.php?folder=$source_folder");
  exit();
 }

if ($empty_trash_request) {
  header("Location: trash.empty.php?user=$owner_id");
  exit();
 }

/* Redirect a trash request appropriately */
if ($delete_request != "") {
  if ($source_album != "") {
    $move_a_request = TRUE;
    $destination_album = "trash";
  } else {
    $move_f_request = TRUE;
    if ($po_user['type'] == PO_USER_TYPE_ADMIN) {
      $destination_folder = "(select identifier from folder where users = $owner_id and caption = 'Trash')";
    } else {
      $destination_folder = $po_user['trash_folder'];
    }
  }
 }

/* Redirect a spool request appropriately. */
if ($spool_request) {
  $link_a_request = TRUE;
  $destination_album = $po_user['spool_album'];
 }


/* Doesn't take arguments */
if ($goto_f_request && ($destination_folder != "")) {
  site_epilog($database);
  header("Location: folder.php?folder=$destination_folder");
  exit();
}

/* Doesn't take arguments */
if ($goto_a_request && ($destination_album != "")) {
  site_epilog($database);
  header("Location: album.php?album=$destination_album");
  exit();
}

/* Make sure spool request is sane */
if ($spool_request && ($versions == "")) {
  site_epilog($database);
  header("Location: $return_path");
  exit();
}

/* Make sure move request is sane */
if ($move_f_request && (($destination_folder == "") ||
		      ($photos == ""))) {
  site_epilog($database);
  header("Location: $return_path");
  exit();
 }

/* Make sure link request is sane */
if ($link_a_request && (($destination_album == "") ||
			($versions == ""))) {
  site_epilog($database);
  header("Location: $return_path");
  exit();
 }

/* Bulk update? */
if ($bulk_update_request) {
  if ($photos != "") {
    header("Location: my.tools.php?selector=1&type=list&selection=$photos");
  } else if ($source_album != "") {
    header("Location: my.tools.php?selector=1&type=album&selection=$source_album");
  } else if ($source_folder != "") {
    header("Location: my.tools.php?selector=1&type=folder&selection=$source_folder");
  } else {
    header("Location: my.tools.php?selector=1");
  }
  exit();
}

if ($move_f_request && ($destination_folder != "")) {
  /* Check ownership on destination folder */
  if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
    $result = pg_query($database, "select identifier from folder where identifier='$destination_folder' and users = $po_user[id]");
    if (pg_num_rows($result) <= 0) {
      site_epilog($database);
      site_push_error($strings['errors']['not_owner']);
      header("Location: $return_path");
      exit();
    }
  }

  /* And perform the move */
  pg_query($database, "begin");
  $clause = "";
  if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
    $clause = " AND users = $po_user[id] ";
  }
  $result = pg_query($database, "update photo set folder=$destination_folder where identifier in ( $photos ) $clause ");

  if (!$result) {
    pg_query($database, "rollback");
    site_push_error($strings['errors']['db_insert_failed']);
  } else {
    pg_query($database, "commit");
  }

 } elseif (($link_a_request || $move_a_request) && ($destination_album != "")) {
   if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
     /* ...to an album that isn't theirs! */
    if ($destination_album != "trash") {
      $result = pg_query($database, "select identifier from album where identifier='$destination_album' and users = $po_user[id]");
      if (pg_num_rows($result) <= 0) {
	site_epilog($database);
	site_push_error($strings['errors']['not_owner']);
	header("Location: $return_path");
	exit();
      }
    }
    /* From a source album they don't own either ... */
    if ($move_a_request) {
      $result = pg_query($database, "select identifier from album where identifier='$source_album' and users = $po_user[id]");
      if (pg_num_rows($result) <= 0) {
	site_epilog($database);
	site_push_error($strings['errors']['not_owner']);
	header("Location: $return_path");
	exit();
      }
    }
   }
  pg_query($database, "begin");

  /* If we're moving the photos to a different album,
     delete them from the original album first */
  if ($source_album != "" && $move_a_request) {
    $result = pg_query($database, "delete from album_content where album=$source_album and version in ( $versions ) ");
  }

  /* Loop through the photos and add them to the destination */
  foreach ($_REQUEST['selection'] as $photo) {
    $parts = explode(":", $photo);
    $photo_identifier = $parts[0];
    $photo_version = $parts[1];
    // print "$photo_identifier $photo_version -- $owner_id $destination_album\n";
    if ($destination_album != "trash") {
      /* Check for duplicates */
      $result = pg_fetch_row(pg_query($database, "select count(*) from album_content where photo = $photo_identifier and version = $photo_version and album = $destination_album"));
      if ($result[0] != 0) {
	continue;
      }

      /* Check that we can read the photo.. */
      $result = pg_fetch_row(pg_query($database, "select can_access_photo($photo_identifier, $po_user[id], '{".$passwords."}');"));
      
      if ($result[0] == 't')				      
	/* Add to album */
	$result = pg_query($database, "insert into album_content (photo, version, album)
                             values ($photo_identifier, $photo_version, $destination_album)");
      // (select v.identifier from photo_version v where v.photo = $photo_identifier and v.master = 't')
      
      if (!$result) {
	site_push_error($strings['errors']['db_insert_failed']);
	pg_query($database, "rollback");
	break;
      }
    }
  }
  pg_query($database, "commit");
} 

site_epilog($database);
header("Location: $return_path");

?>
