<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/orderby.php";
include_once "include/search.2.php";

$folder_id   = pg_escape_string($_REQUEST['folder']);
$offset = pg_escape_string(isset($_REQUEST['offset']) ? $_REQUEST['offset'] : 0);

$database    = site_prolog();
$order_by = $po_options['order_by'];

$folder = FALSE;

if ($folder_id && is_numeric($folder_id)) {
  $folder = pg_fetch_row(pg_query($database, "select caption, access_rights, users, description, password, can_access_folder(folder.identifier, $po_user[id], '{".$passwords."}') from folder where identifier='$folder_id'"));
 }

if (!$folder) {
  header("HTTP/1.1 404 Not found");
  site_header($strings['generic']['display_folder']);
  site_navigator(1);
  site_navigator_status(user_disp_string(0, $po_user['id'], "", ""). " : ". $strings['errors']['no_such_folder'], "");
  site_footer($database);
  site_epilog($database);
  exit();
}

if ($folder[5] == 'f') {
  if ($folder[1] == $access['private']) {
    header("HTTP/1.1 403 Forbidden");
    site_header($strings['generic']['display_folder']);
    site_navigator(1);
    site_navigator_status(user_disp_string(0, $po_user['id'], "", ""). " : ". $strings['errors']['private'], "");
    site_footer($database);
    site_epilog($database);
  } else {
    site_push_error($strings['errors']['protected']);
    header("Location: login.php?reason=protected&orig=".urlencode("folder.php?folder=$folder_id"));
  }
  exit();
 }

/* get the last value from the database */
$folder_name = $folder[0];
$owner_id    = $folder[2];

$user_data = pg_fetch_row(pg_query($database, "
   select last_name, first_name, users.identifier
     from users
    where users.identifier=$owner_id"));

site_header($folder_name);

$user_display_string = user_disp_string($owner_id, $po_user['id'], 
					$user_data[0], $user_data[1]);
$master = "and photo_version.master = 't'";

$froms = array('folder');
$filter = "photo.folder = '$folder_id'
      and folder.identifier = photo.folder
      $master";

$num_of_photos = get_photo_count($database, $froms, $filter);

if ($po_options['photo_view'] == "slide") {
  $limit = $po_options['photos_per_page'];
} else {
  $limit = $po_options['rows_list_view'];
}

/* Sanity checks */
if ($limit > $num_of_photos) {
  $limit = $num_of_photos;
}
while ($num_of_photos && $offset >= $num_of_photos) {
  $offset -= $limit;
}
if ($offset < 0) {
  $offset = 0;
}
if (($offset + $limit) > $num_of_photos) {
  $items = $num_of_photos - $offset;
} else {
  $items = $limit;
}

$path_to_folder = get_path_to_folder($database, $folder_id);

if (($po_user['id'] == $owner_id) &&
    ($folder_id != $po_user['trash_folder']))
  $edit_folder = "[<a href=\"folder.edit.php?folder=$folder_id\">".$strings['generic']['edit']."</a>]";
 else
   $edit_folder = "";

site_navigator(5);

if ($num_of_photos == 0) {
  site_navigator_status("$user_display_string $path_to_folder $edit_folder", $strings['generic']['is_empty']);

  if ($folder[3] != "") {
    folder_comment($folder[3]);
  }
  
  if (($folder_id != $po_user['trash_folder']) &&
      ($folder_name != 'Trash')) {
    display_folders($database, $folder_id, $owner_id, "with_header");
  }
  
  if (($po_user['id'] == $owner_id) &&
      ($folder_id != $po_user['trash_folder'])) {
    print "<div align=\"center\">";
    print "<form name=\"photoList\" method=\"post\" action=\"folder.content.php\">";
    print "<input type=\"hidden\" name=\"source_folder\" value=\"$folder_id\"/>\n";
    print $thm_elem['button.add.photos'];
    print "</form>";
    print "</div>";
  }
  site_footer($database);
  site_epilog($database);
  exit();
 }

$folder_photo = get_photo_query($database, array(), $froms, $filter, $offset, $limit, $order_by);

site_navigator_status("$user_display_string $path_to_folder $edit_folder", $strings['generic']['displaying'] . " " . display_photo_index_status($offset, $limit, $num_of_photos));

if ($folder[3] != "") {
  folder_comment($folder[3]);
 }

if ($folder_name != 'Trash' || $folder_id != $po_user['trash_folder']) {
   display_folders($database, "$folder_id", $owner_id, "with_header");
}

print "<form name=\"photoList\" method=\"post\" action=\"folder.content.php\">";
print "<input type=\"hidden\" name=\"user\" value=\"$owner_id\"/>";
print "<input type=\"hidden\" name=\"photo_view\" value=\"$po_options[photo_view]\"/>";
print "<input type=\"hidden\" name=\"return\" value=\"folder.php?folder=$folder_id&amp;offset=$offset\"/>";
print "<input type=\"hidden\" name=\"source_folder\" value=\"$folder_id\"/>\n";

display_photo_navigator("folder.php?folder=$folder_id", $offset, $limit, $num_of_photos);
if ($po_options['photo_view'] == "slide") {
  $checkboxes = display_photo_slides("folder", $folder_id, $folder_photo, 0, $items, true, true);
} else {
  $checkboxes = display_photo_list("folder", $folder_id, $folder_photo, 0, $items);
}
display_photo_navigator("folder.php?folder=$folder_id", $offset, $limit, $num_of_photos);

site_navigator_status("$user_display_string $path_to_folder $edit_folder", $strings['generic']['displaying'] . " " . display_photo_index_status($offset, $limit, $num_of_photos));

print "<div class=\"actions\">";

if ($checkboxes !== FALSE) {
  display_order_by_combo_with_button($order_by);  
  if ($po_options['photo_view'] == 'slide') {
    display_photos_per_page_combo('photos_per_page', $po_options['photos_per_page']);
  } else {
    display_photos_per_page_combo('rows_list_view', $po_options['rows_list_view']);
  }
 }

print "<table><tr><td>\n";

if ($checkboxes !== FALSE) {
  display_list_slide_option($po_options['photo_view'], "folder.php?folder=$folder_id&amp;offset=$offset");
 }

if ($checkboxes && ($po_user['type'] >= PO_USER_TYPE_CLIENT)) {
  theme_display_selectButton();
  print $thm_elem['button.add.to.spool'];
 }

if (($po_user['id'] == $owner_id) || 
    ($po_user['type'] == PO_USER_TYPE_ADMIN)) {

  if ($folder_name == 'Trash' || $folder_id == $po_user['trash_folder']) {
    if ($checkboxes) 
      print $thm_elem['button.empty.trash'];
  } else {
    if ($po_user['id'] == $owner_id) {
      print $thm_elem['button.add.photos'];
    }
    if ($checkboxes) {
      print $thm_elem['button.delete_s'];
      print $thm_elem['button.bulk.update'];
    }
  }
 }
  
print "</td></tr></table>";

if ($checkboxes) {
  if (($po_user['id'] == $owner_id) || 
      ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
    $folder_all = get_users_folder($database);
    display_folder_actions($folder_all, $folder_id);
  }
  $album_all = get_users_album($database);
  if (pg_num_rows($album_all) > 0) {
    display_album_actions($album_all, '');
  }  
 }

if ($po_user['type'] >= PO_USER_TYPE_CLIENT) {
  display_spool_actions($database, $po_user['id']);
 }

print "</div>";

print "</form>\n";

site_footer($database);
site_epilog($database);
?>
