<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

$nkn_iso_table = array (
  0x00 => "6",    0x01 => "8",    0x02 => "10",   0x03 => "12",
  0x04 => "16",   0x05 => "20",   0x06 => "25",   0x07 => "32",
  0x08 => "40",   0x09 => "50",   0x0A => "64",   0x0B => "80",
  0x0C => "100",  0x0D => "125",  0x0E => "160",  0x0F => "200",
  0x10 => "250",  0x11 => "320",  0x12 => "400",  0x13 => "500",
  0x14 => "640",  0x15 => "800",  0x16 => "1000", 0x17 => "1250",
  0x18 => "1600", 0x19 => "2000", 0x1A => "2500", 0x1B => "3200",
  0x1C => "4000", 0x1D => "5000", 0x1E => "6400", 0x1F => "");

$nkn_exposure_table = array (
  0x00 => "",       0x01 => "",       0x02 => "",
  0x03 => "",       0x04 => "30",     0x05 => "25",
  0x06 => "20",	    0x07 => "20",     0x08 => "15",
  0x09 => "13",	    0x0A => "10",     0x0B => "10",
  0x0C => "8",      0x0D => "6",      0x0E => "6",
  0x0F => "5",      0x10 => "4",      0x11 => "3",
  0x12 => "3",      0x13 => "2.5",    0x14 => "2",
  0x15 => "1.6",    0x16 => "1.45",   0x17 => "1.3",
  0x18 => "1",      0x19 => "1/1.3",  0x1A => "1/1.5",
  0x1B => "1/1.6",  0x1C => "1/2",    0x1D => "1/2.5",
  0x1E => "1/3",    0x1F => "1/3",    0x20 => "1/4",
  0x21 => "1/5",    0x22 => "1/6",    0x23 => "1/6",
  0x24 => "1/8",    0x25 => "1/10",   0x26 => "1/10",
  0x27 => "1/13",   0x28 => "1/15",   0x29 => "1/20",
  0x2A => "1/20",   0x2B => "1/25",   0x2C => "1/30",
  0x2D => "1/40",   0x2E => "1/45",   0x2F => "1/50",
  0x30 => "1/60",   0x31 => "1/80",   0x32 => "1/90",
  0x33 => "1/100",  0x34 => "1/125",  0x35 => "1/160",
  0x36 => "1/180",  0x37 => "1/200",  0x38 => "1/250",
  0x39 => "1/320",  0x3A => "1/350",  0x3B => "1/400",
  0x3C => "1/500",  0x3D => "1/640",  0x3E => "1/750",
  0x3F => "1/800",  0x40 => "1/1000", 0x41 => "1/1250",
  0x42 => "1/1500", 0x43 => "1/1600", 0x44 => "1/2000",
  0x45 => "1/2500", 0x46 => "1/3000", 0x47 => "1/3200",
  0x48 => "1/4000", 0x49 => "1/5000", 0x4A => "1/6000",
  0x4B => "1/6400", 0x4C => "1/8000", 0x4D => "",
  0x4E => "",       0x4F => "",       0x50 => "",
  0x51 => "",       0x52 => "",       0x53 => "",
  0x54 => "",       0x55 => "",       0x56 => "");

$nkn_aperture_table = array (
  0x00 => "1",   0x01 => "1.1", 0x02 => "1.1",
  0x03 => "1.2", 0x04 => "1.2", 0x05 => "1.3",
  0x06 => "1.4", 0x07 => "1.5", 0x08 => "1.6",
  0x09 => "1.7", 0x0A => "1.8", 0x0B => "1.9",
  0x0C => "2",   0x0D => "2.1", 0x0E => "2.2",
  0x0F => "2.4", 0x10 => "2.5", 0x11 => "2.7",
  0x12 => "2.8", 0x13 => "3",   0x14 => "3.2",
  0x15 => "3.3", 0x16 => "3.5", 0x17 => "3.8",
  0x18 => "4",   0x19 => "4.2", 0x1A => "4.5",
  0x1B => "4.8", 0x1C => "5",   0x1D => "5.3",
  0x1E => "5.6", 0x1F => "6",   0x20 => "6.3",
  0x21 => "6.7", 0x22 => "7.1", 0x23 => "7.6",
  0x24 => "8",   0x25 => "8.5", 0x26 => "9",
  0x27 => "9.5", 0x28 => "10",  0x29 => "11",
  0x2A => "11",  0x2B => "12",  0x2C => "13",
  0x2D => "13",  0x2E => "14",  0x2F => "15",
  0x30 => "16",  0x31 => "17",  0x32 => "18",
  0x33 => "19",  0x34 => "20",  0x35 => "21",
  0x36 => "22",  0x37 => "24",  0x38 => "25",
  0x39 => "27",  0x3A => "29",  0x3B => "30",
  0x3C => "32",  0x3D => "34",  0x3E => "36",
  0x3F => "38",  0x40 => "40",  0x41 => "43",
  0x42 => "45",  0x43 => "48",  0x44 => "51",
  0x45 => "54",  0x46 => "57",  0x47 => "60",
  0x48 => "64",  0x49 => "68",  0x4A => "72",
  0x4B => "76",  0x4C => "81",  0x4D => "85",
  0x4E => "90",  0x53 => "",    0x54 => "");

$nkn_camera_program_table = array (
  0x00 => "manual",
  0x01 => "aperture",
  0x02 => "shutter",
  0x03 => "auto",
  0x08 => "auto",
  0x09 => "auto",
  0x0A => "auto",
  0x0B => "auto",
  0x0C => "auto",
  0x0D => "auto",
  0x0E => "auto",
  0x0F => "auto");

$nkn_camera_metering_table = array (
  0x00 => "center",
  0x01 => "spot",
  0x02 => "matrix");

$nkn_flash_mode_table = array (
  0x00 => "normal",
  0x01 => "slow",
  0x02 => "rear",
  0x03 => "");

$nkn_focal_length_table = array (
  0x00 => "",     0x01 => "5",    0x02 => "5.5",
  0x03 => "5.5",  0x04 => "5.5",  0x05 => "5.5",
  0x06 => "6",    0x07 => "6",    0x08 => "6.5",
  0x09 => "6.5",  0x0A => "6.5",  0x0B => "7",
  0x0C => "7",    0x0D => "7",    0x0E => "7.5",
  0x0F => "7.5",  0x10 => "8",    0x11 => "8",
  0x12 => "8.5",  0x13 => "8.5",  0x14 => "9",
  0x15 => "9",    0x16 => "9.5",  0x17 => "9.5",
  0x18 => "10",   0x19 => "10",   0x1A => "10.5",
  0x1B => "11",   0x1C => "11",   0x1D => "11.5",
  0x1E => "12",   0x1F => "12",   0x20 => "13",
  0x21 => "13",   0x22 => "13",   0x23 => "14",
  0x24 => "14",   0x25 => "14",   0x26 => "15",
  0x27 => "15",   0x28 => "16",   0x29 => "16",
  0x2A => "17",   0x2B => "17",   0x2C => "18",
  0x2D => "18",   0x2E => "19",   0x2F => "19",
  0x30 => "20",   0x31 => "20",   0x32 => "21",
  0x33 => "22",   0x34 => "22",   0x35 => "23",
  0x36 => "24",   0x37 => "24",   0x38 => "25",
  0x39 => "26",   0x3A => "26",   0x3B => "27",
  0x3C => "28",   0x3D => "28",   0x3E => "30",
  0x3F => "31",   0x40 => "32",   0x41 => "32",
  0x42 => "34",   0x43 => "34",   0x44 => "35",
  0x45 => "36",   0x46 => "38",   0x47 => "38",
  0x48 => "40",   0x49 => "40",   0x4A => "42",
  0x4B => "44",   0x4C => "45",   0x4D => "46",
  0x4E => "48",   0x4F => "48",   0x50 => "50",
  0x51 => "52",   0x52 => "52",   0x53 => "55",
  0x54 => "56",   0x55 => "58",   0x56 => "60",
  0x57 => "62",   0x58 => "62",   0x59 => "65",
  0x5A => "66",   0x5B => "68",   0x5C => "70",
  0x5D => "72",   0x5E => "75",   0x5F => "78",
  0x60 => "80",   0x61 => "82",   0x62 => "85",
  0x63 => "86",   0x64 => "90",   0x65 => "92",
  0x66 => "95",   0x67 => "98",   0x68 => "100",
  0x69 => "102",  0x6A => "105",  0x6B => "110",
  0x6C => "112",  0x6D => "116",  0x6E => "120",
  0x6F => "122",  0x70 => "125",  0x71 => "130",
  0x72 => "135",  0x73 => "135",  0x74 => "140",
  0x75 => "145",  0x76 => "150",  0x77 => "155",
  0x78 => "160",  0x79 => "165",  0x7A => "171",
  0x7B => "175",  0x7C => "180",  0x7D => "185",
  0x7E => "190",  0x7F => "195",  0x80 => "200",
  0x81 => "210",  0x82 => "210",  0x83 => "220",
  0x84 => "220",  0x85 => "230",  0x86 => "240",
  0x87 => "240",  0x88 => "250",  0x89 => "260",
  0x8A => "270",  0x8B => "270",  0x8C => "280",
  0x8D => "290",  0x8E => "300",  0x8F => "310",
  0x90 => "320",  0x91 => "330",  0x92 => "340",
  0x93 => "350",  0x94 => "360",  0x95 => "370",
  0x96 => "380",  0x97 => "390",  0x98 => "400",
  0x99 => "410",  0x9A => "420",  0x9B => "440",
  0x9C => "450",  0x9D => "460",  0x9E => "480",
  0x9F => "490",  0xA0 => "500",  0xA1 => "500",
  0xA2 => "550",  0xA3 => "550",  0xA4 => "550",
  0xA5 => "600",  0xA6 => "600",  0xA7 => "600",
  0xA8 => "650",  0xA9 => "650",  0xAA => "650",
  0xAB => "700",  0xAC => "700",  0xAD => "750",
  0xAE => "750",  0xAF => "800",  0xB0 => "800",
  0xB1 => "800",  0xB2 => "850",  0xB3 => "850",
  0xB4 => "900",  0xB5 => "900",  0xB6 => "950",
  0xB7 => "1000", 0xB8 => "1000", 0xB9 => "1050",
  0xBA => "1050", 0xBB => "1100", 0xBC => "1150",
  0xBD => "1150", 0xBE => "1200", 0xBF => "1250",
  0xC0 => "1300", 0xC1 => "1300", 0xC2 => "1300",
  0xC3 => "1400", 0xC4 => "1400", 0xC5 => "1500",
  0xC6 => "1500", 0xC7 => "1600", 0xC8 => "1600",
  0xC9 => "1600", 0xCA => "1700", 0xCB => "1700",
  0xCC => "1800", 0xCD => "1800", 0xCE => "1900",
  0xCF => "2000", 0xD0 => "2000", 0xD1 => "2100",
  0xD2 => "2100", 0xD3 => "2200", 0xD4 => "2300",
  0xD5 => "2300", 0xD6 => "2400", 0xD7 => "2500",
  0xD8 => "2500", 0xD9 => "2600", 0xDA => "2700",
  0xDB => "2800", 0xDC => "2900", 0xDD => "2900",
  0xDE => "3000", 0xDF => "3100", 0xE0 => "3200",
  0xE1 => "3300", 0xE2 => "3400", 0xE3 => "3500",
  0xE4 => "3600", 0xE5 => "3700", 0xE6 => "3800",
  0xE7 => "3900", 0xE8 => "4000", 0xE9 => "4100",
  0xEA => "4300", 0xEB => "4400", 0xEC => "4500",
  0xED => "4700", 0xEE => "4800", 0xEF => "4900",
  0xF0 => "5100", 0xF1 => "5200", 0xF2 => "5400",
  0xF3 => "5500", 0xF4 => "5700", 0xF5 => "5900",
  0xF6 => "6000", 0xF7 => "6200", 0xF8 => "6400",
  0xF9 => "6600", 0xFA => "6800", 0xFB => "7000",
  0xFC => "7200", 0xFD => "7400", 0xFE => "7600",
  0xFF => "");

$nkn_exp_comp_table = array (
  0x00 => "0.0",    0x01 => "-0.2",   0x02 => "-0.3",   0x03 => "-0.5",
  0x04 => "-0.7",   0x05 => "-0.8",   0x06 => "-1.0",   0x07 => "-1.2",
  0x08 => "-1.3",   0x09 => "-1.5",   0x0A => "-1.7",   0x0B => "-1.8",
  0x0C => "-2.0",   0x0D => "-2.2",   0x0E => "-2.3",   0x0F => "-2.5",
  0x10 => "-2.7",   0x11 => "-2.8",   0x12 => "-3.0",   0x13 => "-3.2",
  0x14 => "-3.3",   0x15 => "-3.5",   0x16 => "-3.7",   0x17 => "-3.8",
  0x18 => "-4.0",   0x19 => "-4.2",   0x1A => "-4.3",   0x1B => "-4.5",
  0x1C => "-4.7",   0x1D => "-4.8",   0x1E => "-5.0",   0x1F => "-5.2",
  0x20 => "-5.3",   0x21 => "-5.5",   0x22 => "-5.7",   0x23 => "-5.8",
  0x24 => "-6.0",   0x25 => "-6.2",   0x26 => "-6.3",   0x27 => "-6.5",
  0x28 => "-6.7",   0x29 => "-6.8",   0x2A => "-7.0",   0x2B => "-7.2",
  0x2C => "-7.3",   0x2D => "-7.5",   0x2E => "-7.7",   0x2F => "-7.8",
  0x30 => "-8.0",   0x31 => "-8.2",   0x32 => "-8.3",   0x33 => "-8.5",
  0x34 => "-8.7",   0x35 => "-8.8",   0x36 => "-9.0",   0x37 => "-9.2",
  0x38 => "-9.3",   0x39 => "-9.5",   0x3A => "-9.7",   0x3B => "-9.8",
  0x3C => "-10.0",  0x3D => "-10.2",  0x3E => "-10.3",  0x3F => "-10.5",
  0x40 => "-10.7",  0x41 => "-10.8",  0x42 => "-11.0",  0x43 => "-11.2",
  0x44 => "-11.3",  0x45 => "-11.5",  0x46 => "-11.7",  0x47 => "-11.8",
  0x48 => "-12.0",  0x49 => "-12.2",  0x4A => "-12.3",  0x4B => "-12.5",
  0x4C => "-12.7",  0x4D => "-12.8",  0x4E => "-13.0",  0x4F => "-13.2",
  0x50 => "-13.3",  0x51 => "-13.5",  0x52 => "-13.7",  0x53 => "-13.8",
  0x54 => "-14.0",  0x55 => "-14.2",  0x56 => "-14.3",  0x57 => "-14.5",
  0x58 => "-14.7",  0x59 => "-14.8",  0x5A => "-15.0",  0x5B => "-15.2",
  0x5C => "-15.3",  0x5D => "-15.5",  0x5E => "-15.7",  0x5F => "-15.8",
  0x60 => "-16.0",  0x61 => "-16.2",  0x62 => "-16.3",  0x63 => "-16.5",
  0x64 => "-16.7",  0x65 => "-16.8",  0x66 => "-17.0",  0x67 => "-17.2",
  0x68 => "-17.3",  0x69 => "-17.5",  0x6A => "-17.7",  0x6B => "-17.8",
  0x6C => "-18.0",  0x6D => "-18.2",  0x6E => "-18.3",  0x6F => "-18.5",
  0x70 => "-18.7",  0x71 => "-18.8",  0x72 => "-19.0",  0x73 => "-19.2",
  0x74 => "-19.3",  0x75 => "-19.5",  0x76 => "-19.7",  0x77 => "-19.8",
  0x78 => "-20.0",  0x79 => "-20.0",  0x7A => "-20.0",  0x7B => "-20.0",
  0x7C => "-20.0",  0x7D => "-20.0",  0x7E => "-20.0",  0x7F => "-20.0",
  0x80 => "+20.0",  0x81 => "+20.0",  0x82 => "+20.0",  0x83 => "+20.0",
  0x84 => "+20.0",  0x85 => "+20.0",  0x86 => "+20.0",  0x87 => "+20.0",
  0x88 => "+20.0",  0x89 => "+19.8",  0x8A => "+19.7",  0x8B => "+19.5",
  0x8C => "+19.3",  0x8D => "+19.2",  0x8E => "+19.0",  0x8F => "+18.8",
  0x90 => "+18.7",  0x91 => "+18.5",  0x92 => "+18.3",  0x93 => "+18.2",
  0x94 => "+18.0",  0x95 => "+17.8",  0x96 => "+17.7",  0x97 => "+17.5",
  0x98 => "+17.3",  0x99 => "+17.2",  0x9A => "+17.0",  0x9B => "+16.8",
  0x9C => "+16.7",  0x9D => "+16.5",  0x9E => "+16.3",  0x9F => "+16.2",
  0xA0 => "+16.0",  0xA1 => "+15.8",  0xA2 => "+15.7",  0xA3 => "+15.5",
  0xA4 => "+15.3",  0xA5 => "+15.2",  0xA6 => "+15.0",  0xA7 => "+14.8",
  0xA8 => "+14.7",  0xA9 => "+14.5",  0xAA => "+14.3",  0xAB => "+14.2",
  0xAC => "+14.0",  0xAD => "+13.8",  0xAE => "+13.7",  0xAF => "+13.5",
  0xB0 => "+13.3",  0xB1 => "+13.2",  0xB2 => "+13.0",  0xB3 => "+12.8",
  0xB4 => "+12.7",  0xB5 => "+12.5",  0xB6 => "+12.3",  0xB7 => "+12.2",
  0xB8 => "+12.0",  0xB9 => "+11.8",  0xBA => "+11.7",  0xBB => "+11.5",
  0xBC => "+11.3",  0xBD => "+11.2",  0xBE => "+11.0",  0xBF => "+10.8",
  0xC0 => "+10.7",  0xC1 => "+10.5",  0xC2 => "+10.3",  0xC3 => "+10.2",
  0xC4 => "+10.0",  0xC5 => "+9.8",   0xC6 => "+9.7",   0xC7 => "+9.5",
  0xC8 => "+9.3",   0xC9 => "+9.2",   0xCA => "+9.0",   0xCB => "+8.8",
  0xCC => "+8.7",   0xCD => "+8.5",   0xCE => "+8.3",   0xCF => "+8.2",
  0xD0 => "+8.0",   0xD1 => "+7.8",   0xD2 => "+7.7",   0xD3 => "+7.5",
  0xD4 => "+7.3",   0xD5 => "+7.2",   0xD6 => "+7.0",   0xD7 => "+6.8",
  0xD8 => "+6.7",   0xD9 => "+6.5",   0xDA => "+6.3",   0xDB => "+6.2",
  0xDC => "+6.0",   0xDD => "+5.8",   0xDE => "+5.7",   0xDF => "+5.5",
  0xE0 => "+5.3",   0xE1 => "+5.2",   0xE2 => "+5.0",   0xE3 => "+4.8",
  0xE4 => "+4.7",   0xE5 => "+4.5",   0xE6 => "+4.3",   0xE7 => "+4.2",
  0xE8 => "+4.0",   0xE9 => "+3.8",   0xEA => "+3.7",   0xEB => "+3.5",
  0xEC => "+3.3",   0xED => "+3.2",   0xEE => "+3.0",   0xEF => "+2.8",
  0xF0 => "+2.7",   0xF1 => "+2.5",   0xF2 => "+2.3",   0xF3 => "+2.2",
  0xF4 => "+2.0",   0xF5 => "+1.8",   0xF6 => "+1.7",   0xF7 => "+1.5",
  0xF8 => "+1.3",   0xF9 => "+1.2",   0xFA => "+1.0",   0xFB => "+0.8",
  0xFC => "+0.7",   0xFD => "+0.5",   0xFE => "+0.3",   0xFF => "+0.2");


function convert_xml2html($string) {
  $string = ereg_replace("<", "&lt;", $string);
  $string = ereg_replace(">", "&gt;", $string);
  $string = ereg_replace("\"", "&quot;", $string);
  /* replace \n with <br/>*/
  $string = ereg_replace("\n", "<br/>", $string);
  return $string;
}

function create_xml_header() {
  $xml_string = "<?xml version='1.0'?>\n";
  $xml_string .= "<!DOCTYPE BULKUPLOAD SYSTEM \"http://po.shaftnet.org/_media/po.dtd/\">\n";
  return $xml_string;
}

function create_xml_bulkupload_header() {
  return "<bulkupload>\n";
}

function create_xml_folder_header($folder_id) {
  return "<folder id=\"$folder_id\">\n";
}

function create_xml_folder_footer() {
  return "</folder>\n";
}

function create_xml_bulkupload_footer() {
  return "</bulkupload>\n";
}

function create_xml_photo($image_data) {
  $xml_string = "<photo";
  if ($image_data['title'])
    $xml_string .= " title=\"".$image_data['title']."\"";
  $xml_string .= ">\n";

  if ($image_data['caption'])
    $xml_string .= "<caption>".$image_data['caption']."</caption>\n";
  if ($image_data['keywords'])
    foreach ($image_data['keywords'] as $keyword) {
      $xml_string .= "<keyword>".$keyword."</keyword>\n";
    }
  if ($image_data['copyright'])
    $xml_string .= "<copyright>".$image_data['copyright']."</copyright>\n";
  if ($image_data['author'])
    $xml_string .= "<author>".$image_data['author']."</author>\n";

  foreach($image_data['file'] as $version) {
    $xml_string .= "<file name=\"".$version['name']."\"";
    if ($version['remark'])
      $xml_string .= " remark=\"".$version['remark']."\"";
    if ($version['master'] == 't')
      $xml_string .= " master=\"yes\"";
    $xml_string .= "/>\n";
  }

if ($image_data['date_of_exposure'] != "null") {

  $exposure_year  = substr($image_data['date_of_exposure'], 0, 4);
  $exposure_month = substr($image_data['date_of_exposure'], 5, 2);
  $exposure_day   = substr($image_data['date_of_exposure'], 8, 2);
  $exposure_hour  = substr($image_data['date_of_exposure'], 11, 2);
  $exposure_min   = substr($image_data['date_of_exposure'], 14, 2);
  $exposure_sec   = substr($image_data['date_of_exposure'], 17, 2);

  if ($exposure_year || $exposure_month || $exposure_day) {
    $xml_string .= "<expdate";
    if ($exposure_year)
      $xml_string .= " year=\"$exposure_year\"";
    if ($exposure_month)
      $xml_string .= " month=\"$exposure_month\"";
    if ($exposure_day)
      $xml_string .= " day=\"$exposure_day\"";
    if ($exposure_hour)
      $xml_string .= " hours=\"$exposure_hour\"";
    if ($exposure_min)
      $xml_string .= " minutes=\"$exposure_min\"";
    if ($exposure_sec)
      $xml_string .= " seconds=\"$exposure_sec\"";
    $xml_string .= " />\n";
  }
}

  if ($image_data['location'] && $image_data['location'] != "null")
    $xml_string .= "<location id=\"".$image_data['location']."\" />\n";

  if ($image_data['latitude'] || $image_data['longitude'] || 
      $image_data['altitude'] || $image_data['direction']) {
    $xml_string .= "<geolocation ";

    if ($image_data['latitude']) $xml_string .= "latitude=\"$image_data[latitude]\" ";
    if ($image_data['altitude']) $xml_string .= "altitude=\"$image_data[altitude]\" ";
    if ($image_data['longitude']) $xml_string .= "longitude=\"$image_data[longitude]\" ";
    if ($image_data['direction']) $xml_string .= "direction=\"$image_data[direction]\" ";
    
    $xml_string .= "/>\n";
  }

  if (($image_data['storage_location_type'] && $image_data['storage_location_type'] != "null") ||
      ($image_data['storage_location_id'] && $image_data['storage_location_id'] != "null") ||
      ($image_data['storage_index'] && $image_data['storage_index'] != "null")) {
    $xml_string .= "<storage";
    if ($image_data['storage_location_type'] && $image_data['storage_location_type'] != "null") 
      $xml_string .= " type=\"".$image_data['storage_location_type']."\"";
    if ($image_data['storage_location_id'] && $image_data['storage_location_id'] != "null") 
      $xml_string .= " id=\"".$image_data['storage_location_id']."\"";
    if ($image_data['storage_index'] && $image_data['storage_index'] != "null")
      $xml_string .= " idx=\"".$image_data['storage_index']."\"";
    $xml_string .= " />\n";
  }

  if (($image_data['access_rights'] && $image_data['access_rights'] != "null") ||
      ($image_data['hide_original'] && $image_data['hide_original'] != "null")) {
    $xml_string .= "<access";
    if (($image_data['access_rights'] && $image_data['access_rights'] != "null"))
      $xml_string .= " type=\"".$image_data['access_rights']."\"";
    if (($image_data['hide_original'] && $image_data['hide_original'] != "null"))
      $xml_string .= " original=\"".$image_data['hide_original']."\"";
    $xml_string .= " />\n";
  }

  if ($image_data['store_url'] != "") {
    $xml_string .= "<purchase url=\"$image_data[store_url]\" />\n";
  }

  if ($image_data['remark'] != "") {
    $xml_string .= "<remark>$image_data[remark]</remark>\n";
  }

  if (($image_data['camera'] && $image_data['camera'] != "null") ||
      ($image_data['camera_metering'] && $image_data['camera_metering'] != "null") ||
      ($image_data['camera_program'] && $image_data['camera_program'] != "null") ||
      ($image_data['shutter'] && $image_data['shutter'] != "null") ||
      ($image_data['exp_comp'] && $image_data['exp_comp'] != "null" && $image_data['exp_comp'] != "0.0") ||
      ($image_data['exp_diff'] && $image_data['exp_diff'] != "null" && $image_data['exp_diff'] != "0.0")) {
    $xml_string .= "<camera";
    if ($image_data['camera'] && $image_data['camera'] != "null")
      $xml_string .= " id=\"".$image_data['camera']."\"";
    if ($image_data['camera_metering'] && $image_data['camera_metering'] != "null")
      $xml_string .= " meter=\"".$image_data['camera_metering']."\"";
    if ($image_data['camera_program'] && $image_data['camera_program'] != "null")
      $xml_string .= " prog=\"".$image_data['camera_program']."\"";
    if ($image_data['shutter'] && $image_data['shutter'] != "null")
      $xml_string .= " speed=\"".$image_data['shutter']."\"";
    if ($image_data['exp_comp'] && $image_data['exp_comp'] != "null" && $image_data['exp_comp'] != "0.0")
      $xml_string .= " comp=\"".$image_data['exp_comp']."\"";
    if ($image_data['exp_diff'] && $image_data['exp_diff'] != "null" && $image_data['exp_diff'] != "0.0")
      $xml_string .= " diff=\"".$image_data['exp_diff']."\"";
    $xml_string .= " />\n";
  }

  if (($image_data['lens'] && $image_data['lens'] != "null") ||
      ($image_data['focal_length'] && $image_data['focal_length'] != "null") ||
      ($image_data['aperture'] && $image_data['aperture'] != "null")) {
    $xml_string .= "<lens";
    if ($image_data['lens'] && $image_data['lens'] != "null")
      $xml_string .= " id=\"".$image_data['lens']."\"";
    if ($image_data['focal_length'] && $image_data['focal_length'] != "null")
      $xml_string .= " focal=\"".$image_data['focal_length']."\"";
    if ($image_data['aperture'] && $image_data['aperture'] != "null")
      $xml_string .= " apert=\"".$image_data['aperture']."\"";
    $xml_string .= " />\n";
  }

  if ($image_data['filter'] && $image_data['filter'] != "null")
    $xml_string .= "<filter id=\"".$image_data['filter']."\" />\n";

  if (($image_data['film'] && $image_data['film'] != "null") ||
      ($image_data['iso_override'] && $image_data['iso_override'] != "null")) {
    $xml_string .= "<film";
    if ($image_data['film'] && $image_data['film'] != "null")
      $xml_string .= " id=\"".$image_data['film']."\"";
    if ($image_data['iso_override'] && $image_data['iso_override'] != "null")
      $xml_string .= " override=\"".$image_data['iso_override']."\"";
    $xml_string .= " />\n";
  }

  if (($image_data['flash'] && $image_data['flash'] != "null") ||
      ($image_data['flash_mode'] && $image_data['flash_mode'] != "null") ||
      ($image_data['flash_comp'] && $image_data['flash_comp'] != "null" && $image_data['flash_comp'] != "0.0")) {
    $xml_string .= "<flash";
    if ($image_data['flash'] && $image_data['flash'] != "null")
      $xml_string .= " id=\"".$image_data['flash']."\"";
    if ($image_data['flash_mode'] && $image_data['flash_mode'] != "null")
      $xml_string .= " mode=\"".$image_data['flash_mode']."\"";
    if ($image_data['flash_comp'] && $image_data['flash_comp'] != "null" && $image_data['flash_comp'] != "0.0")
      $xml_string .= " comp=\"".$image_data['flash_comp']."\"";
    $xml_string .= " />\n";
  }

  if (($image_data['scanner'] && $image_data['scanner'] != "null") ||
      ($image_data['scan_resolution'] && $image_data['scan_resolution'] != "null") ||
      ($image_data['scan_bitdepth'] && $image_data['scan_bitdepth'] != "null") ||
      ($image_data['scan_multiscan'] && $image_data['scan_multiscan'] != "null")) {
    $xml_string .= "<scanner";
    if ($image_data['scanner'] && $image_data['scanner'] != "null")
      $xml_string .= " id=\"".$image_data['scanner']."\"";
    if ($image_data['scan_resolution'] && $image_data['scan_resolution'] != "null")
      $xml_string .= " dpi=\"".$image_data['scan_resolution']."\"";
    if ($image_data['scan_bitdepth'] && $image_data['scan_bitdepth'] != "null")
      $xml_string .= " bitdepth=\"".$image_data['scan_bitdepth']."\"";
    if ($image_data['scan_multiscan'] && $image_data['scan_multiscan'] != "null")
      $xml_string .= " pass=\"".$image_data['scan_multiscan']."\"";
    $xml_string .= " />\n";
  }

  if ($image_data['support'] && $image_data['support'] != "null")
    $xml_string .= "<support id=\"".$image_data['support']."\" />\n";

  $xml_string .= "</photo>\n";

  return $xml_string;
}

function read_nkn_string($fd) {
  $length = fread($fd,1);
  $length = ord($length);
  return fread($fd, $length);
}

function convert_read_header($fd, $format) {
  global $nkn_iso_table;

  switch ($format):
  case ".sdf":
    for ($i = 0; $i < 7; $i++) {
      $buffer = fgets($fd, 4096);
      if ($i == 5) {
        strtok($buffer," \t");
        $iso = strtok(" \t");
      }
    }
  break;
  case ".txt":
    for ($i = 0; $i < 6; $i++) {
      $buffer = fgets($fd, 4096);
      if ($i == 3) {
        strtok($buffer,"\t");
        $iso = strtok("\t");
      }
    }
  break;
  case ".nkn":
    $header = read_nkn_string($fd);
    $version = fread($fd, 2);
    $timestamp = fread($fd, 4);
    $roll_title = read_nkn_string($fd);
    $camera_type = read_nkn_string($fd);
    $iso = ord(fgetc($fd));
    $iso = $nkn_iso_table[$iso];
  break;

  endswitch;
  return array(iso => $iso);
}


function convert_read_body($fd, $format) {
  global $nkn_exposure_table;
  global $nkn_aperture_table;
  global $nkn_camera_program_table;
  global $nkn_camera_metering_table;
  global $nkn_flash_mode_table;
  global $nkn_focal_length_table;
  global $nkn_exposure_table;
  global $nkn_exposure_table;

  $frames = 0;

  if ($format == ".nkn") {
    $storage_level = ord(fgetc($fd));
    fread($fd, 3);
    $total_frames = ord(fgetc($fd));
    fread($fd, 1);
  }

  while (!feof ($fd)) {
    switch ($format):
    case ".sdf":
      $buffer = fgets($fd, 4096);
      /* do this twice */
      $buffer = str_replace("\t\t", "\t \t", $buffer);
      $buffer = str_replace("\t\t", "\t \t", $buffer);
      $fram_number      = strtok($buffer,"\t");

      if (!$fram_number)
        break;

      $shutter          = strtok("\t");
      $aperture         = strtok("\t");
      $flash_mode       = strtok("\t");
      $camera_metering  = strtok("\t");
      $camera_program   = strtok("\t");
      $focal_length     = strtok("\t");
      $exp_comp         = strtok("\t");
      $minimum_aperture = strtok("\t");
      $ev_diff          = strtok("\t");
      $day              = strtok("\t");
      $time             = strtok("\t");
      $data_imprint     = strtok("\t");
      $caption          = strtok("\t");
      break;
    case ".txt":
      $buffer = fgets($fd, 4096);
      /* do this twice */
      $buffer = str_replace("\t\t", "\t \t", $buffer);
      $buffer = str_replace("\t\t", "\t \t", $buffer);
      $fram_number      = strtok($buffer,"\t");

      if (!$fram_number)
        break;

      $shutter          = strtok("\t");
      $aperture         = strtok("\t");
      $camera_program   = strtok("\t");
      $camera_metering  = strtok("\t");
      $flash_mode       = strtok("\t");
      $focal_length     = strtok("\t");
      $exp_comp         = strtok("\t");
      $flash_comp       = strtok("\t");
      $caption          = strtok("\t");
      break;
    case ".nkn":
      $caption = read_nkn_string($fd);
      $shutter = $nkn_exposure_table[ord(fgetc($fd))];
      $aperture = $nkn_aperture_table[ord(fgetc($fd))];  /* rpCameraApertureEffective  */
      $camera_program = $nkn_camera_program_table[ord(fgetc($fd))];  /* rpNKN_ProgramMode  */
      $camera_metering = $nkn_camera_metering_table[ord(fgetc($fd))];  /* rpNKN_LightMetering  */
      if ($storage_level > 0x00) {
        $flash_mode = $nkn_flash_mode_table[ord(fgetc($fd))];  /* rpNKN_FlashMode  */
        $focal_length = $nkn_focal_length_table[ord(fgetc($fd))];  /* rpCameraFocusDistance  */
        if ($storage_level > 0x01) {
          $exp_comp = $nkn_exposure_table[ord(fgetc($fd))];  /* rpNKN_Compensation  */
          $flash_comp = $nkn_exposure_table[ord(fgetc($fd))];  /* rpNKN_Compensation  */
        }
      }

      break;
    default:
      return;
    endswitch;

    $shutter = strtolower($shutter);
    $shutter = str_replace(" ",  "", $shutter);
    $shutter = str_replace("\"", "", $shutter);
    $shutter = str_replace("hi", "", $shutter);
    $shutter = str_replace("lo", "", $shutter);

    $aperture = strtolower($aperture);
    $aperture = str_replace("/", "", $aperture);
    $aperture = str_replace("f", "", $aperture);
    $aperture = str_replace("-", "", $aperture);
    $aperture = str_replace(" ", "", $aperture);
    $focal_length = str_replace("mm", "", $focal_length);
    $focal_length = str_replace("-", "", $focal_length);
    $focal_length = str_replace(" ", "", $focal_length);

    $flash_mode = strtok($flash_mode, " ");
    $flash_mode = strtolower($flash_mode);
    $flash_mode = str_replace(" ", "", $flash_mode);
    $flash_mode = str_replace("-", "", $flash_mode);

    $camera_metering = strtok($camera_metering, " ");
    $camera_metering = strtolower($camera_metering);
    $camera_program = strtok($camera_program, " ");
    $camera_program = strtolower($camera_program);

    if ($camera_metering == "colour")
      $camera_metering = "colormatrix";

    if ($camera_program == "a")
      $camera_program = "aperture";
    elseif ($camera_program == "s")
      $camera_program = "shutter";
    elseif ($camera_program == "m")
      $camera_program = "manual";
    else
      $camera_program = "auto";

    $shooting_data[$frames] = array('shutter'          => $shutter,
                                    'aperture'         => $aperture,
                                    'flash_mode'       => $flash_mode,
                                    'camera_metering'  => $camera_metering,
                                    'camera_program'   => $camera_program,
                                    'focal_length'     => $focal_length,
                                    'exp_comp'         => $exp_comp,
                                    'minimum_aperture' => $minimum_aperture,
                                    'ev_diff'          => $ev_diff,
                                    'caption'          => $caption);

    $frames++;
  }

  return array('frames' => $frames, 'data' => $shooting_data);
}

?>
