/<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "barcode.php";

function pdf_MakeCode128Digit($x, $y1, $y2, $n) {
  $return_string = "";
  if ($n > 107)
    return $return_string;

  global $code128Bits;

  for($i = 0; $i < 11; $i++) {
    if ($code128Bits[$n][1][$i])
      $return_string =  $return_string . "$x $y1 m $x $y2 l\r\n";
    $x++;
  }
  /* finish sequence */
  if ($n == 106) {
    $return_string =  $return_string . "$x $y1 m $x $y2 l\r\n";
    $x++;
    $return_string =  $return_string . "$x $y1 m $x $y2 l\r\n";
  }
  $return_string =  $return_string . "S\r\n";
  return $return_string;
}

function pdf_DrawCode128BarCode($string, $type, $storage_info, $xoffset, $yoffset, $width, $height, $border) {
  $return_string = "";
  global $code128Bits;

  $xoffset += $border;
  $yoffset += $border;
  $width   -= $border;
  $height  -= $border;

  $fontsize = $width/15;

  $return_string = $return_string . "0 0 0 RG\r\n";
  $return_string = $return_string . "1 w\r\n";       /* set line width to 1 */


  if ($storage_info != "") {
    $y = $yoffset - $height;
    $x = $xoffset + $width;
    $return_string = $return_string . "BT\r\n/HF $fontsize Tf\r\n$x $y Td ($storage_info) Tj\r\nET\r\n";
  }

  switch (type) {
  case 0:
  case 1:
    $ypos = $yoffset - $height;
    $return_string = $return_string . "BT\r\n/HF $fontsize Tf\r\n$xoffset $ypos Td ($string) Tj\r\nET\r\n";
    break;
  case 2:
    $xpos = $xoffset - $height;
    $ypos = $yoffset - $height;
    $return_string = $return_string . "BT\r\n/HF $fontsize Tf\r\n$xpos $ypos Td (";
    for ($i = 0; $i < $stringlength; $i++)
      $return_string = $return_string . "string[$i] ";
    $return_string = $return_string . ") Tj\r\nET\r\n";
    break;
  default:
    return "";
  }

  $return_string = $return_string . "S\r\n";

  $stringlength = strlen($string);
  $pixelwidth = ($stringlength + 3) * 11 + 1;

  if ($width == -$border)
    $xscale = 1;
  else {
    $xscale = $width/$pixelwidth;
    $xoffset *= 1/$xscale;
  }

  if ($height == 0) {
    $height = 30;
  }

  $x = $xoffset;

  $return_string = $return_string . "$xscale 0 0 1 0 0 cm\r\n";
  $return_string = $return_string . "0 0 0 RG\r\n";
  $return_string = $return_string . "1 w\r\n";

  $digit = pdf_MakeCode128Digit($x, $yoffset - $height + $fontsize, $yoffset, 103+$type, $code128Bits);
  $return_string = $return_string . $digit;
  $checksum = 103 + $type;
  $x += 11;

  for ($i = 0; $i < $stringlength; $i++) {
    for($j = 0; $j < 107; $j++) {
      if ($code128Bits[$j][0][$type] == $string[$i]) {
        $checksum += $j*($i+1);
        $digit = pdf_MakeCode128Digit($x, $yoffset - $height + $fontsize, $yoffset, $j, $code128Bits);
        $return_string = $return_string . $digit;
      }
    }
    $x += 11;
  }

  $checksum = $checksum%103;

  $digit = pdf_MakeCode128Digit($x, $yoffset - $height + $fontsize, $yoffset, $checksum, $code128Bits);
  $return_string = $return_string . $digit;
  $x += 11;

  $digit = pdf_MakeCode128Digit($x, $yoffset - $height + $fontsize, $yoffset, 106, $code128Bits);
  $return_string = $return_string . $digit;

  $return_string = $return_string . "S\r\n";

  return $return_string;
}


function pdf_DrawMeteringMode($x, $y, $size) {
  $return_string = "";

  $fontsize = $width/15;

  $return_string = $return_string . "0 0 0 RG\r\n";
  $return_string = $return_string . "1 w\r\n";       /* set line width to 1 */

  $height = $x + $size;
  $width  = $y + $size * 0.65;

  $nx = $x + $height;
  $ny = $y + $width;

  $return_string =  $return_string . "$x $y m\r\n";
  $return_string =  $return_string . "$nx $y l\r\n";
  $return_string =  $return_string . "$nx $ny l\r\n";
  $return_string =  $return_string . "$x $ny l\r\n";
  $return_string =  $return_string . "h\r\n";

  $return_string = $return_string . "S\r\n";
  return $return_string;
}

$object_address  = array();
$num_of_objects  = 0;
$current_address = 0;

$helvetica_font_object = 0;
$courier_bold_font_object = 0;
$courier_bold_oblique_font_object = 0;

function pdf_Header($file, $width, $height) {
  global $object_address;
  global $num_of_objects;
  global $current_address;

  $object_address[$num_of_objects] = 0;
  $current_address += fwrite($file, "%PDF-1.4\r\n");
  $num_of_objects++;
}

function pdf_Catalog($file, $pages_object, $outlines_object) {
  global $object_address;
  global $num_of_objects;
  global $current_address;

  $object_address[$num_of_objects] = $current_address;
  $current_address += fwrite($file, "$num_of_objects 0 obj\r\n");
  $current_address += fwrite($file, "<<\r\n/Type /Catalog\r\n/Pages $pages_object 0 R\r\n/Outlines $outlines_object 0 R\r\n>>\r\n");
  $current_address += fwrite($file, "endobj\r\n");
  $num_of_objects++;
}

function pdf_ProcSet($file) {
  global $object_address;
  global $num_of_objects;
  global $current_address;

  $object_address[$num_of_objects] = $current_address;
  $current_address += fwrite($file, "$num_of_objects 0 obj\r\n");
  $current_address += fwrite($file, "[/PDF /Text /ImageB /ImageC /ImageI]\r\n");
  $current_address += fwrite($file, "endobj\r\n");
  $num_of_objects++;
}

function pdf_Outlines($file) {
  global $object_address;
  global $num_of_objects;
  global $current_address;

  $object_address[$num_of_objects] = $current_address;
  $current_address += fwrite($file, "$num_of_objects 0 obj\r\n");
  $current_address += fwrite($file, "<<\r\n/Type /Outlines\r\n/Count 0\r\n>>\r\n");
  $current_address += fwrite($file, "endobj\r\n");
  $num_of_objects++;
}

function pdf_Pages($file, $num_of_pages, $page_size, $content, $procset ) {
  global $object_address;
  global $num_of_objects;
  global $current_address;

  $object_address[$num_of_objects] = $current_address;
  $current_address += fwrite($file, "$num_of_objects 0 obj\r\n");
  $parent_page = $num_of_objects;
  $num_of_objects++;
  $kid_object = $num_of_objects + 3;
  $current_address += fwrite($file, "<<\r\n/Type /Pages\r\n/Count $num_of_pages\r\n/Kids [$kid_object 0 R]\r\n>>\r\n");
  $current_address += fwrite($file, "endobj\r\n");

  $helvetica_font_object = $num_of_objects;
  $object_address[$num_of_objects] = $current_address;
  $current_address += fwrite($file, "$num_of_objects 0 obj\r\n");
  $current_address += fwrite($file, "<<\r\n/Type /Font\r\n/Subtype /Type1\r\n/Name /HF\r\n/BaseFont /Helvetica\r\n/Encoding /MacRomanEncoding\r\n>>\r\n");
  $current_address += fwrite($file, "endobj\r\n");
  $num_of_objects++;

  $courier_bold_font_object = $num_of_objects;
  $object_address[$num_of_objects] = $current_address;
  $current_address += fwrite($file, "$num_of_objects 0 obj\r\n");
  $current_address += fwrite($file, "<<\r\n/Type /Font\r\n/Subtype /Type1\r\n/Name /CBF\r\n/BaseFont /Courier-Bold\r\n/Encoding /MacRomanEncoding\r\n>>\r\n");
  $current_address += fwrite($file, "endobj\r\n");
  $num_of_objects++;

  $courier_bold_oblique_font_object = $num_of_objects;
  $object_address[$num_of_objects] = $current_address;
  $current_address += fwrite($file, "$num_of_objects 0 obj\r\n");
  $current_address += fwrite($file, "<<\r\n/Type /Font\r\n/Subtype /Type1\r\n/Name /CBOF\r\n/BaseFont /Courier-BoldOblique\r\n/Encoding /MacRomanEncoding\r\n>>\r\n");
  $current_address += fwrite($file, "endobj\r\n");
  $num_of_objects++;

  for ($i = 0; $i < $num_of_pages; $i++) {
    $object_address[$num_of_objects] = $current_address;
    $current_address += fwrite($file, "$num_of_objects 0 obj\r\n");
    $current_address += fwrite($file, "<<\r\n/Type /Page\r\n");
    if ($i != ($num_of_pages - 1)) {
      $kid_page = $num_of_objects + 1;
      $current_address += fwrite($file, "/Kids [$kid_page 0 R]\r\n");
    }
    $current_address += fwrite($file, "/Parent $parent_page 0 R\r\n");
    $current_address += fwrite($file, "/Resources\r\n<<\r\n/Font\r\n<<\r\n");
    $current_address += fwrite($file, "/HF $helvetica_font_object 0 R\r\n");
    $current_address += fwrite($file, "/CBF $courier_bold_font_object 0 R\r\n");
    $current_address += fwrite($file, "/CBOF $courier_bold_oblique_font_object 0 R\r\n");
    $current_address += fwrite($file, ">>\r\n/ProcSet $procset 0 R\r\n>>\r\n");
    $current_address += fwrite($file, "/MediaBox [0 0 $page_size[x] $page_size[y]]\r\n");
    $current_address += fwrite($file, "/Contents $content[$i] 0 R\r\n>>\r\n");
    $current_address += fwrite($file, "endobj\r\n");
    $parent_page = $num_of_objects;
    $num_of_objects++;
  }
}


function pdf_Footer($file, $root_object, $title, $author, $subject, $version) {
  global $object_address;
  global $num_of_objects;
  global $current_address;
  $date_of_creation = date("YmdHis");

  $info_object = $num_of_objects;
  $object_address[$num_of_objects] = $current_address;
  $current_address += fwrite($file, "$num_of_objects 0 obj\r\n");
  $current_address += fwrite($file, "<<\r\n/Producer (Photo Organizer $version)\r\n/Subject ($subject)\r\n/Creator ($author)\r\n/Title ($title)\r\n/Author ($author)\r\n/ModDate (D:$date_of_creation-00'00')\r\n/CreationDate (D:$date_of_creation-00'00')\r\n>>\r\n");
  $current_address += fwrite($file, "endobj\r\n");
  $num_of_objects++;

  fwrite($file, "xref\r\n0 $num_of_objects\r\n");
  for ($i = 0; $i < $num_of_objects; $i++) {
    $cross_reference_address = str_pad($object_address[$i], 10, "0", STR_PAD_LEFT);
    fwrite($file, $cross_reference_address);
    if ($object_address[$i] == 0)
      fwrite($file, " 65535 f\r\n");
    else
      fwrite($file, " 00000 n\r\n");
  }
  fwrite($file, "trailer\r\n");
  fwrite($file, "<<\r\n");
  fwrite($file, "/Size $num_of_objects\r\n");
  fwrite($file, "/Info $info_object 0 R\r\n");
  fwrite($file, "/Root $root_object 0 R\r\n");
  fwrite($file, ">>\r\n");
  fwrite($file, "startxref\r\n");
  fwrite($file, "$current_address\r\n");
  fwrite($file, "%%EOF\r\n");
}

function pdf_StreamObject($file, $title, $stream) {
  global $object_address;
  global $num_of_objects;
  global $current_address;

  $stream_length = strlen($stream) + 1;
  $object_address[$num_of_objects] = $current_address;
  $current_address += fwrite($file, "$num_of_objects 0 obj\r\n");
  $current_address += fwrite($file, "<<\r\n/Title ($title)\r\n/Length $stream_length\r\n>>\r\nstream\r\n$stream\r\nendstream\r\n");
  $current_address += fwrite($file, "endobj\r\n");
  $num_of_objects++;
}


$file = fopen("../tmp/test.pdf", "w");
pdf_Header($file, $x_paper, $y_paper);
$outlines_object = $num_of_objects;
pdf_Outlines($file);
$procset_object = $num_of_objects;
pdf_ProcSet($file);


$page_content_object = $num_of_objects;
$stream = pdf_DrawCode128BarCode("0091223", 1, "STORAGE 2 : 1", 200, 600, 200, 60, 10);
$stream = pdf_DrawMeteringMode(200, 200, 100);

pdf_StreamObject($file, "Sample barcode", $stream);
$content = array($page_content_object);
$page_size = array('x' => 612, 'y' => 792);
$pages_object = $num_of_objects;
pdf_Pages($file, 1, $page_size, $content, $procset_object);
$root_object = $num_of_objects;
pdf_Catalog($file, $pages_object, $outlines_object);
pdf_Footer($file, $root_object, "Labels", "Balint Kis; balint@k-i-s.net", "label printout", "PHP:2.5.C-SQL:2.3.C");
fclose($file);

print "<a href=\"../tmp/test.pdf\">test.pdf</a>"

?>
