<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

$profile_data = array();

function profile_i18n_data() {
  global $profile_data;
  global $strings;

  $profile_data = array("lens"         => array("idx" => 1, 'link' => "my.profile.php?selector=1",  "alt" => $strings['generic']['lenses']),
                      "camera"       => array("idx" => 2, 'link' => "my.profile.php?selector=2",  "alt" => $strings['generic']['cameras']),
                      "flash"        => array("idx" => 3,  'link' => "my.profile.php?selector=3",  "alt" => $strings['generic']['flashes']),
                      "scanner"      => array("idx" => 4, 'link' => "my.profile.php?selector=4",  "alt" => $strings['generic']['scanners']),
                      "filter"       => array("idx" => 5, 'link' => "my.profile.php?selector=5",  "alt" => $strings['generic']['filters']),
                      "film"         => array("idx" => 6, 'link' => "my.profile.php?selector=6",  "alt" => $strings['generic']['films']),
                      "support"      => array("idx" => 7, 'link' => "my.profile.php?selector=7",  "alt" => $strings['generic']['supports']),
                      "manufacturer" => array("idx" => 8, 'link' => "my.profile.php?selector=8",  "alt" => $strings['generic']['manufacturers']),
                      "label"        => array("idx" => 9, 'link' => "my.profile.php?selector=9",  "alt" => $strings['generic']['labels']),
                      "location"     => array("idx" => 10, 'link' => "my.profile.php?selector=10", "alt" => $strings['generic']['locations']));
}

$generate_i18n_data[] = "profile_i18n_data";

function display_lens($database, $viewer_id, $owner_id) {
  global $access;
  global $strings;

  if ($viewer_id==$owner_id) {
    $all_lenses = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length, serial_number, date_of_purchase, purchased_new, url, access_rights, number_of_lens_references(identifier) as photos
                                         from view_lens where users=$owner_id order by name");
  } else {
    $client = FALSE;
    if ($viewer_id != FALSE)
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$owner_id' and client='$viewer_id' and status=2"));
    if ($client == FALSE)
      $all_lenses = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length, serial_number, date_of_purchase, purchased_new, url, access_rights, number_of_lens_references(identifier) as photos
                                           from view_lens where users=$owner_id and access_rights=$access[public] order by name");
    else
      $all_lenses = pg_query($database, "select identifier, name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length, serial_number, date_of_purchase, purchased_new, url, access_rights, number_of_lens_references(identifier) as photos
                                           from view_lens where users=$owner_id and access_rights<=$access[protected] order by name");
  }

  $num_of_lenses = pg_num_rows($all_lenses);
  if ($viewer_id != $owner_id && $num_of_lenses == 0)
    return;

  print "<table class=\"profile\">\n";
  print "<tr>\n";
  print emit_th($strings['profile']['id_no'], "width=\"5%\"");
  print emit_th($strings['profile']['model'], "width=\"35%\"");
  print emit_th($strings['profile']['serial'], "width=\"13%\"");
  print emit_th($strings['profile']['purchased'], "width=\"16%\"");
  print emit_th($strings['profile']['new'], "width=\"5%\"");
  if ($viewer_id==$owner_id) {
    print emit_th($strings['generic']['photos'], "width=\"5%\"");
    print emit_th($strings['generic']['access'], "width=\"10%\"");
    print "<th width=\"10%\" colspan=\"2\"><a href=\"lens.add.php\">".$strings['generic']['add']."</a></th>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_lenses; $i++) {
    $lens = pg_fetch_row($all_lenses, $i);
    print "<tr>\n";
    print "<td>$lens[0]</td>\n";
    print "<td><a target=\"new\" href=\"$lens[11]\">$lens[1]</a> $lens[2] $lens[3]\n";
    print emit_lens_string($lens[4], $lens[5], $lens[6], $lens[7]);
    print "</td>\n";
    print "<td>$lens[8]</td>\n";
    print emit_td(emit_date_html($lens[9], 'date'));
    print emit_td(emit_yes_no_text($lens[10]));
    if ($viewer_id==$owner_id) {
      print "<td>$lens[13]</td>\n";
      print emit_td($strings['generic'][$access[$lens[12]]]);
      print "<td><a href=\"lens.edit.php?item=$lens[0]\">".$strings['generic']['edit']."</a></td>\n";
      print "<td><a href=\"lens.del.php?item=$lens[0]\">".$strings['generic']['delete']."</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_camera($database, $viewer_id, $owner_id) {
  global $access;
  global $icc_profiles;
  global $strings;

  if ($viewer_id==$owner_id) {
    $all_cameras = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights, raw_icc_profile, number_of_camera_references(identifier) as photos, ignore_comment
                                          from view_camera where users=$owner_id order by name");
  } else {
    $client = FALSE;
    if ($viewer_id != FALSE)
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$owner_id' and client='$viewer_id' and status=2"));
    if ($client == FALSE)
      $all_cameras = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights, raw_icc_profile, number_of_camera_references(identifier) as photos, ignore_comment
                                            from view_camera where users=$owner_id and access_rights=$access[public] order by name");
    else
      $all_cameras = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights, raw_icc_profile, number_of_camera_references(identifier) as photos, ignore_comment
                                            from view_camera where users=$owner_id and access_rights<=$access[protected] order by name");
  }

  $num_of_cameras = pg_num_rows($all_cameras);
  if ($viewer_id!=$owner_id && $num_of_cameras == 0)
    return;

  print "<table class=\"profile\">\n";
  print "<tr>\n";
  print emit_th($strings['profile']['id_no'], "width=\"5%\"");
  print emit_th($strings['profile']['model'], "width=\"25%\"");
  print emit_th($strings['profile']['serial'], "width=\"13%\"");
  print emit_th($strings['profile']['purchased'], "width=\"16%\"");
  print emit_th($strings['profile']['new'], "width=\"5%\"");
  print emit_th($strings['profile']['ignore_comment'], "width=\"10%\"");
  if ($viewer_id==$owner_id) {
    print emit_th($strings['generic']['photos'], "width=\"5%\"");
    print emit_th($strings['generic']['access'], "width=\"5%\"");
    print emit_th($strings['profile']['icc_profile'], "width=\"10%\"");
    print "<th width=\"7%\" colspan=\"2\"><a href=\"camera.add.php\">".$strings['generic']['add']."</a></th>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_cameras; $i++) {
    $camera = pg_fetch_row($all_cameras, $i);
    print "<tr>\n";
    print "<td>$camera[0]</td>\n";
    print "<td><a target=\"new\" href=\"$camera[7]\">$camera[1]</a> $camera[2] $camera[3]</td>\n";
    print "<td>$camera[4]</td>\n";
    print "<td>".emit_date_html($camera[5], 'date'). "</td>\n";
    print emit_td(emit_yes_no_text($camera[6]));
    print emit_td(emit_yes_no_text($camera[11]));
    if ($viewer_id==$owner_id) {
      print "<td>$camera[10]</td>\n";
      print emit_td($strings['generic'][$access[$camera[8]]]);
      if ($camera[9] != "")
	print "<td>" . $icc_profiles[$camera[9]]['name'] . "</td>\n";
      else 
	print "<td></td>\n";
      print "<td><a href=\"camera.edit.php?item=$camera[0]\">".$strings['generic']['edit']."</a></td>\n";
      print "<td><a href=\"camera.del.php?item=$camera[0]\">".$strings['generic']['delete']."</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

/* type is:  flash filter support scanner [camera film lens not yet] */
function display_profile($database, $type, $viewer_id, $owner_id) {
  global $access;
  global $strings;

  if ($viewer_id==$owner_id) {
    $all = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights, number_of_".$type."_references(identifier) as photos
                                          from view_$type where users=$owner_id order by name");
  } else {
    $client = FALSE;
    if ($viewer_id != FALSE)
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$owner_id' and client='$viewer_id' and status=2"));
    if ($client == FALSE)
      $all = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                            from view_$type where users=$owner_id and access_rights=$access[public] order by name");
    else
      $all = pg_query($database, "select identifier, name, model, variation, serial_number, date_of_purchase, purchased_new, url, access_rights
                                            from view_$type where users=$owner_id and access_rights<=$access[protected] order by name");
  }

  $num_of = pg_num_rows($all);
  if ($viewer_id!=$owner_id && $num_of == 0)
    return;

  print "<table class=\"profile\">\n";
  print "<tr>\n";
  print emit_th($strings['profile']['id_no'], "width=\"5%\"");
  print emit_th($strings['profile']['model'], "width=\"35%\"");
  print emit_th($strings['profile']['serial'], "width=\"13%\"");
  print emit_th($strings['profile']['purchased'], "width=\"16%\"");
  print emit_th($strings['profile']['new'], "width=\"5%\"");
  if ($viewer_id==$owner_id) {
    print emit_th($strings['generic']['photos'], "width=\"5%\"");
    print emit_th($strings['generic']['access'], "width=\"10%\"");
    print "<th width=\"7%\" colspan=\"2\"><a href=\"profile.add.php?type=$type\">".$strings['generic']['add']."</a></th>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of; $i++) {
    $item = pg_fetch_row($all, $i);
    print "<tr>\n";
    print "<td>$item[0]</td>\n";
    print "<td><a target=\"new\" href=\"$item[7]\">$item[1]</a> $item[2] $item[3]</td>\n";
    print "<td>$item[4]</td>\n";
    print "<td>".emit_date_html($item[5], 'date'). "</td>\n";
    print emit_td(emit_yes_no_text($item[6]));
    if ($viewer_id==$owner_id) {
      print "<td>$item[9]</td>\n";
      print emit_td($strings['generic'][$access[$item[8]]]);
      print "<td><a href=\"profile.edit.php?type=$type&amp;item=$item[0]\">".$strings['generic']['edit']."</a></td>\n";
      print "<td><a href=\"profile.del.php?type=$type&amp;item=$item[0]\">".$strings['generic']['delete']."</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_film($database, $viewer_id, $owner_id) {
  global $access;
  global $strings;

  if ($viewer_id==$owner_id) {
    $all_films = pg_query($database, "select identifier, name, model, iso, format, url, access_rights,  number_of_film_references(identifier) as photos
                                        from view_film where users=$owner_id order by name");
  } else {
    $client = FALSE;
    if ($viewer_id != FALSE)
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$owner_id' and client='$viewer_id' and status=2"));
    if ($client == FALSE)
      $all_films = pg_query($database, "select identifier, name, model, iso, format, url, access_rights, number_of_film_references(identifier) as photos
                                          from view_film where users=$owner_id and access_rights=$access[public] order by name");
    else
      $all_films = pg_query($database, "select identifier, name, model, iso, format, url, access_rights, number_of_film_references(identifier) as photos
                                          from view_film where users=$owner_id and access_rights<=$access[protected] order by name");
  }

  $num_of_films = pg_num_rows($all_films);
  if ($viewer_id!=$owner_id && $num_of_films == 0)
    return;

  print "<table class=\"profile\">\n";
  print "<tr>\n";
  print emit_th($strings['profile']['id_no'], "width=\"5%\"");
  print emit_th($strings['profile']['model'], "width=\"35%\"");
  print emit_th($strings['profile']['iso'], "width=\"7%\"");
  print emit_th($strings['profile']['format'], "width=\"20%\"");
  if ($viewer_id==$owner_id) {
    print emit_th($strings['generic']['photos'], "width=\"5%\"");
    print emit_th($strings['generic']['access'], "width=\"10%\"");
    print "<th width=\"10%\" colspan=\"2\"><a href=\"film.add.php\">".$strings['generic']['add']."</a></th>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_films; $i++) {
    $film = pg_fetch_row($all_films, $i);
    print "<tr>\n";
    print "<td>$film[0]</td>\n";
    print "<td><a target=\"new\" href=\"$film[5]\">$film[1] $film[2]</a></td>\n";
    print "<td>$film[3]</td>";
    print "<td>$film[4]</td>\n";
    if ($viewer_id==$owner_id) {
      print "<td>$film[7]</td>\n";
      print emit_td($strings['generic'][$access[$film[6]]]);
      print "<td><a href=\"film.edit.php?item=$film[0]\">".$strings['generic']['edit']."</a></td>\n";
      print "<td><a href=\"film.del.php?item=$film[0]\">".$strings['generic']['delete']."</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_manufacturer($database, $viewer_id, $owner_id) {
  global $access;
  global $strings;

  if ($owner_id == "*")
    $all_manufacturers = pg_query($database, "select identifier, name, url, last_modified_date from manufacturer order by name");
  else
    $all_manufacturers = pg_query($database, "select identifier, name, url, last_modified_date
                                                from manufacturer where last_modifying_users=$owner_id order by name");

  $num_of_manufacturers = pg_num_rows($all_manufacturers);
  if ($owner_id == "*" && $num_of_manufacturers == 0)
    return;

  print "<table class=\"profile\">\n";
  if ($owner_id == "*") {
    print "<tr class=\"folder_top\">\n";
    print "<td colspan=\"4\">".sprintf($strings['profile']['all'], $strings['generic']['manufacturers'])."</td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print emit_th($strings['profile']['id_no'], "width=\"5%\"");
  print emit_th($strings['generic']['name'], "width=\"25%\"");
  print emit_th($strings['user']['web'], "width=\"40%\"");
  print emit_th($strings['generic']['created'], "width=\"20%\"");
  if ($owner_id != "*")
    print "<th width=\"10%\" colspan=\"2\"><a href=\"manufacturer.add.php\">".$strings['generic']['add']."</a></th>\n";
  print "</tr>\n";

  for ($i=0; $i < $num_of_manufacturers; $i++) {
    $manufacturer = pg_fetch_row($all_manufacturers, $i);
    print "<tr>\n";
    print "<td>$manufacturer[0]</td>\n";
    print "<td><a target=\"_new\" href=\"$manufacturer[2]\">$manufacturer[1]</a></td>\n";
    print "<td><a target=\"_new\" href=\"$manufacturer[2]\">$manufacturer[2]</a></td>\n";
    print "<td>".emit_date_html($manufacturer[3], 'date'). "</td>\n";
    if ($owner_id != "*") {
      print "<td><a href=\"manufacturer.edit.php?item=$manufacturer[0]\">".$strings['generic']['edit']."</a></td>\n";
      print "<td><a href=\"manufacturer.del.php?item=$manufacturer[0]\">".$strings['generic']['delete']."</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_label($database, $owner_id) {
  global $po_user;
  global $strings;

  $viewer_id = $po_user['id'];

  if ($owner_id == "*") {
    $all_labels = pg_query($database, "
      select label.identifier,
             (select url from manufacturer where identifier=label.manufacturer),
             (select name from manufacturer where identifier=label.manufacturer),
             label.name, paper.name,
             space_x, space_y, label.size_x, label.size_y, offset_x, offset_y,
             columns, rows, date_of_creation
        from label, paper
       where label.paper=paper.identifier
       order by label.identifier");
  } else {
    $all_labels = pg_query($database, "
      select label.identifier,
             (select url from manufacturer where identifier=label.manufacturer),
             (select name from manufacturer where identifier=label.manufacturer),
             label.name, paper.name,
             space_x, space_y, label.size_x, label.size_y, offset_x, offset_y,
             columns, rows, date_of_creation
        from label, paper
       where label.paper=paper.identifier
         and label.users=$viewer_id
       order by label.identifier");
  }

  $num_of_labels = pg_num_rows($all_labels);
  if ($owner_id == "*" && $num_of_labels == 0)
    return;

  print "<table class=\"profile\">\n";
  if ($owner_id == "*") {
    print "<tr class=\"folder_top\">\n";
    print "<td colspan=\"11\">".sprintf($strings['profile']['all'], $strings['generic']['labels'])."</td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print emit_th($strings['profile']['id_no'], "width=\"5%\"");
  print emit_th($strings['profile']['model'], "width=\"25%\"");
  print emit_th($strings['label']['h_space'], "width=\"5%\"");
  print emit_th($strings['label']['v_space'], "width=\"5%\"");
  print emit_th($strings['label']['width'], "width=\"5%\"");
  print emit_th($strings['label']['height'], "width=\"5%\"");
  print emit_th($strings['label']['h_offset'], "width=\"5%\"");
  print emit_th($strings['label']['v_offset'], "width=\"5%\"");
  print emit_th($strings['label']['rows'], "width=\"5%\"");
  print emit_th($strings['label']['columns'], "width=\"5%\"");
  print emit_th($strings['generic']['created'], "width=\"20%\"");
  if ($owner_id != "*") {
    print "<th width=\"10%\" colspan=\"2\"><a href=\"label.add.php\">".$strings['generic']['add']."</a></th>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num_of_labels; $i++) {
    $label = pg_fetch_row($all_labels, $i);
    print "<tr>\n";
    print "<td>$label[0]</td>\n";
    print "<td><a target=\"_new\" href=\"$label[1]\">$label[2]</a> $label[3], $label[4]</td>\n";
    print "<td>$label[5]</td>\n";
    print "<td>$label[6]</td>\n";
    print "<td>$label[7]</td>\n";
    print "<td>$label[8]</td>\n";
    print "<td>$label[9]</td>\n";
    print "<td>$label[10]</td>\n";
    print "<td>$label[11]</td>\n";
    print "<td>$label[12]</td>\n";
    print "<td>".emit_date_html($label[13], 'date'). "</td>\n";
    if ($owner_id != "*") {
      print "<td><a href=\"label.edit.php?item=$label[0]\">".$strings['generic']['edit']."</a></td>\n";
      print "<td><a href=\"label.del.php?item=$label[0]\">".$strings['generic']['delete']."</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_location($database, $viewer_id) {
  global $po_user;
  global $strings;

  $filter = " where private is false ";
  if ($po_user['type'] == PO_USER_TYPE_ADMIN)
    $filter = "";

  if ($viewer_id == "*") {
    $result = pg_query($database, "
  select view_location.identifier, place, city, state, country,
         last_modified_date, latitude, longitude,
         number_of_location_references(view_location.identifier) as photos,
         private
    from view_location
         $filter
order by country, state, city, place");
  } else {
    $result = pg_query($database, "
  select view_location.identifier, place, city, state, country,
         last_modified_date, latitude, longitude, 
         number_of_location_references(view_location.identifier) as photos,
         private
   from view_location
       where users=$viewer_id
order by country, state, city, place");
  }

  $num = pg_num_rows($result);

  print "<table class=\"profile\">\n";
  if ($viewer_id == "*") {
    print "<tr class=\"folder_top\">\n";
    print "<td colspan=\"7\">".sprintf($strings['profile']['all'], $strings['generic']['locations'])."</td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print emit_th($strings['profile']['id_no'], "width=\"5%\"");
  print emit_th($strings['generic']['description'], "width=\"40%\"");
  print emit_th($strings['photo']['latitude'], "width=\"8%\"");
  print emit_th($strings['photo']['longitude'], "width=\"8%\"");
  print emit_th($strings['generic']['created'], "width=\"15%\"");
  print emit_th($strings['generic']['photos'], "width=\"5%\"");
  if ($viewer_id != "*") {
    print emit_th($strings['generic']['private'], "width=\"5%\"");
    print "<th width=\"10%\" colspan=\"2\"><a href=\"location.add.php\">".$strings['generic']['add']."</a></th>\n";
  }
  print "</tr>\n";

  for ($i=0; $i < $num; $i++) {
    $r = pg_fetch_row($result, $i);
    if ($r[1] != '' && ($r[2] != '' || $r[3] != '' ||  $r[4] != '')) {
      $r[1] = sprintf("%s,", $r[1]);
    }
    if ($r[2] != '' && ($r[3] != '' ||  $r[4] != '')) {
      $r[2] = sprintf("%s,", $r[2]);
    }
    if ($r[3] != '' && $r[4] != '') {
      $r[3] = sprintf("%s,", $r[3]);
    }
    print "<tr>\n";
    print "<td>$r[0]</td>\n";

    if ($r[1] == 'Unknown')  $r[1] = $strings['generic']['unknown'];

    print "<td>$r[1] $r[2] $r[3] $r[4]</td>\n";
    print "<td>$r[6]</td>\n";
    print "<td>$r[7]</td>\n";
    print "<td>".emit_date_html($r[5], 'date')."</td>\n";
    print "<td>$r[8]</td>\n";
    if ($viewer_id != "*") {
      print emit_td(emit_yes_no_text($r[9]));
      print "<td><a href=\"location.edit.php?item=$r[0]\">".$strings['generic']['edit']."</a></td>\n";
      print "<td><a href=\"location.del.php?item=$r[0]\">".$strings['generic']['delete']."</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}

/* type is:  flash filter camera film support scanner lens */
function profile_del_item ($database, $type, $identifier)
{
  global $po_user;
  global $strings;

  $type = pg_escape_string($type);
  $identifer = pg_escape_string($identifier);

  $type_to_remove = FALSE;

  if ($identifier != "") {

    /* Ensure the user owns it !*/
    if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
      $result = pg_fetch_row(pg_query($database, "select count(identifier) from $type where identifier=$identifier and users=$po_user[id]"));
      if ($result[0] == 0) {
	return FALSE;
      }
    }

    pg_query($database, "begin");
    $number_of_same_type = pg_fetch_row(pg_query($database, "select count(identifier) from $type where type=(select type from $type where identifier='$identifier')"));
    if ($number_of_same_type[0] == 1) {
      $type_to_remove = pg_fetch_row(pg_query($database, "select type from $type where identifier='$identifier'"));
    }

    $result = pg_query($database, "delete from $type where identifier='$identifier'");
    if (!$result) {
      pg_query($database, "rollback");
      site_push_error($strings['errors']['db_insert_failed']);
      return FALSE;
    }

    if ($number_of_same_type[0] == 1) {
      $result = pg_query($database, "delete from ".$type."_type where identifier='$type_to_remove[0]'");
      if (!$result) {
        pg_query($database, "rollback");
	site_push_error($strings['errors']['db_insert_failed']);
        return FALSE;
      }
    }
    pg_query($database, "commit");
  }
  return TRUE;
}

/* type = flash, filter, scanner, support  [lens film camera won't work] */
function profile_update_item($database, $identifier, $user_id, $type,
			     $type_id, $manufacturer_id, 
			     $model, $variation, $serial,
			     $date_of_purchase,  $purchased_new,
			     $access_rights)
{
  global $po_user;
  global $strings;

  $user_id = pg_escape_string($user_id);
  $type = pg_escape_string($type);

  $identifier = pg_escape_string($identifier);
  $model = pg_escape_string($model);
  $variation = pg_escape_string($variation);
  $serial = pg_escape_string($serial);
  $date_of_purchase = check_date_validity($date_of_purchase);
  $purcahsed_new = pg_escape_string($purchased_new);
  $access_rights = pg_escape_string($access_rights);
  
  $type_to_remove = FALSE;

  /* Ensure the user owns it !*/
  if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
    $result = pg_fetch_row(pg_query($database, "select count(identifier) from $type where identifier=$identifier and users=$user_id"));
    if ($result[0] == 0) {
      return FALSE;
    }
  }

  pg_query($database, "begin");

  if ($type_id=='custom') {
    /* type has changed */
    $number_of_same_type = pg_fetch_row(pg_query($database, "select count(identifier) from $type where type=(select type from $type where identifier='$identifier')"));
    if ($number_of_same_type[0] == 1) {
      /* there was only one of this kind, so we have to remove it */
      $type_to_remove = pg_fetch_row(pg_query($database, "select type from $type where identifier='$identifier'"));
    }

    /* create new type */
    $new_type_id = pg_fetch_row(pg_query($database, "select nextval('".$type."_type_id_sequence')"));
    $type_id = $new_type_id[0];
    $result = pg_query($database, "insert into ".$type."_type (identifier, manufacturer, model, variation, last_modified_date, last_modifying_users)
                                   values ($type_id, $manufacturer_id, '$model', '$variation', now(), $user_id)");
    if (!$result) {
      pg_query($database, "rollback");
      site_push_error($strings['errors']['db_insert_failed']);
      return FALSE;
    }
  }

  /* add item */
  $result = pg_query($database, "update $type set type=$type_id, serial_number='$serial', date_of_purchase=$date_of_purchase, purchased_new='$purchased_new', access_rights='$access_rights'  where identifier='$identifier'");
  if (!$result) {
    pg_query($database, "rollback");
    site_push_error($strings['errors']['db_insert_failed']);
    return FALSE;
  }

  /* remove old type */
  if ($type_to_remove) {
    $result = pg_query($database, "delete from ".$type."_type where identifier='$type_to_remove[0]'");
    if (!$result) {
      pg_query($database, "rollback");
      site_push_error($strings['errors']['db_insert_failed']);
      return FALSE;
    }
  }

  pg_query($database, "commit");

  return TRUE;
}
			   
?>
