<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
include_once "include/common.php";

$type = 'lens';

$database = site_prolog(PO_USER_TYPE_USER);

$manufacturer_filter = pg_escape_string(isset($_REQUEST['filter']) ? $_REQUEST['filter'] : "");
$lens_id             = pg_escape_string($_REQUEST['item']);

$lens_current_value = pg_fetch_row(pg_query($database, "select name, model, variation, s_min_aperture,
                                                               s_max_aperture, s_min_focal_length, s_max_focal_length,
                                                               serial_number, date_of_purchase, purchased_new, access_rights, users, exiftool_lens_id
                                                          from view_lens where identifier='$lens_id'"));

/* Ensure the user owns it !*/
if (($po_user['id'] != $lens_current_value[11]) &&
    ($po_user['type'] != PO_USER_TYPE_ADMIN)) {
  site_epilog($database);
  site_push_error($strings['errors']['not_owner']);
  header("Location: login.php");
  exit();
 }

$lens_type_current_value = pg_fetch_row(pg_query($database, "select type from lens where identifier='$lens_id'"));
$manufacturer = pg_query($database, "select identifier, name from manufacturer order by name");

switch ($manufacturer_filter) {
 case 'All':
 case '':
   $lens_type = pg_query($database, "select identifier, name, model, variation, s_min_aperture,
                                            s_max_aperture, s_min_focal_length, s_max_focal_length, url, exiftool_lens_id 
                                       from view_lens_type order by name");
   break;
 default:
   $lens_type = pg_query($database, "select identifier, name, model, variation, s_min_aperture,
                                            s_max_aperture, s_min_focal_length, s_max_focal_length, url, exiftool_lens_id
                                       from view_lens_type where name='$manufacturer_filter' or identifier='$lens_type_current_value[0]' order by name");
}

site_header(sprintf($strings['profile']['edit'], $strings['generic'][$type]));
site_navigator(6);
site_navigator_status(emit_a("user.php", $strings['generic']['users'])." : ".emit_a("my.profile.php", $strings['generic']['my_profile'])." : ".sprintf($strings['profile']['edit'], $strings['generic'][$type]), "");

theme_display_navigator_box_top($profile_data['lens']['idx'], $profile_data, "100%");

print "<form method=\"post\" action=\"lens.edit.2.php?item_id=$lens_id\">\n";
print "<table class=\"profile\">\n";

emit_profile_manuf_combo("lens.edit.php?type=$type&amp;item=$lens_id", $type, 5, $manufacturer, $manufacturer_filter);

print "<tr>\n";
print "<th width=\"4%\"></th>\n";
print emit_th($strings['profile']['manufacturer'], "width=\"15%\"");
print emit_th($strings['profile']['model'], "width=\10%\"");
print emit_th($strings['profile']['variation'], "width=\"10%\"");
print emit_th($strings['profile']['aperture_focal'], "width=\"20%\"");
print emit_th($strings['profile']['exiftool_id'], "width=\"30%\"");
print "</tr>\n";

$num = pg_num_rows($lens_type);
if ($num > 0) {
  for ($i=0; $i < $num; $i++) {
    $r = pg_fetch_row($lens_type, $i);
    print "<tr>\n";
    print "<td><input type=\"radio\" name=\"lens_type_id\" value=\"$r[0]\" /></td>\n";
    print "<td><a target=\"_new\" href=\"$r[8]\">$r[1]</a></td>\n";
    print "<td>$r[2]</td>\n";
    print "<td>$r[3]</td>\n";
    print "<td>";
    print emit_lens_string($r[4], $r[5], $r[6], $r[7]);
    print "</td>\n";
    print "<td>$r[9]</td>\n";
    print "</tr>\n";
  }
 } else {
  print "<tr><td colspan=\"4\">".sprintf($strings['profile']['none_found'], $strings['generic'][$type])." ".$strings['generic']['types'] ."</td></tr>\n";
 }

print "</table>\n";

print "<table class=\"profile\">\n";
print "<tr class=\"folder_top\">\n";
print "<td colspan=\"7\">".sprintf($strings['profile']['edit_type'], $strings['generic'][$type])."</td>\n";
print "</tr>\n";
print "<tr>\n";
print "<th width=\"4%\"></th>\n";
print emit_th($strings['profile']['manufacturer'], "width=\"15%\"");
print emit_th($strings['profile']['model'], "width=\"10%\"");
print emit_th($strings['profile']['variation'], "width=\"10%\"");
print emit_th($strings['generic']['aperture'], "width=\"15%\"");
print emit_th($strings['generic']['focal_length'], "width=\"15%\"");
print emit_th($strings['profile']['exiftool_id'], "width=\"15%\"");
print "</tr>\n";

print "<tr>\n";
print "<td>";
print "<input type=\"radio\" name=\"lens_type_id\" value=\"custom\" checked=\"checked\" />";
print "</td>\n";
print "<td>";
print emit_manufacturer_combo('manufacturer_id', $manufacturer, $lens_current_value[0]);
print "</td>\n";
print "<td>";
print "<input type=\"text\" name=\"lens_model\" value=\"$lens_current_value[1]\" />\n";
print "</td>\n";
print "<td>\n";
print "<input type=\"text\" name=\"lens_variation\" value=\"$lens_current_value[2]\"/>\n";
print "</td>\n";
print "<td>";
print emit_aperture_combo("lens_min_aperture_id", $lens_current_value[3], 1);
print "-";
print emit_aperture_combo("lens_max_aperture_id", $lens_current_value[4], 1);
print "</td>\n";
print "<td>";
print emit_focal_length_combo("lens_min_focal_length_id", $lens_current_value[5], 1);
print "-";
print emit_focal_length_combo("lens_max_focal_length_id", $lens_current_value[6], 1);
print "</td>\n";
print "<td>";
print "<input type=\"text\" name=\"exiftool_lens_id\" value=\"$lens_current_value[12]\"/>\n";
print "</td>\n";
print "</tr>\n";
print "</table>\n";

print "<table class=\"profile\">\n";
print "<tr class=\"folder_top\">";
print "<tr class=\"folder_top\"><td colspan=\"4\">".sprintf($strings['profile']['specific_data'], $strings['generic'][$type])."</td></tr>\n";

print "<tr>\n";
print emit_th($strings['profile']['serial']);
print emit_th($strings['profile']['purchased']);
print emit_th($strings['profile']['new']);
print emit_th($strings['generic']['access']);
print "</tr>\n";

print "<tr>\n";
print "<td><input type=\"text\" name=\"lens_serial_number\" value=\"$lens_current_value[7]\" /></td>\n";
$date_of_purchase= substr($lens_current_value[8], 0, 10);
print "<td>\n";
print emit_date_input_form("lens_purchase_timestamp", $date_of_purchase);
print "</td>\n";
print "<td>\n"; display_yes_no_combo("lens_purchased_new", $lens_current_value[9]); print "</td>\n";
print "<td>\n"; display_access_combo("lens_access_rights", $lens_current_value[10], ""); print "</td>\n";
print "</tr>\n";
print "</table>\n";

print $thm_elem['button.save.changes'];
print $thm_elem['button.clear'];
print $thm_elem['button.cancel'];
print "</form>\n";

theme_display_navigator_box_bottom("100%");

site_footer($database);
site_epilog($database);
?>
