<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";

$database = site_prolog(PO_USER_TYPE_USER);

$photo_id    = pg_escape_string($_REQUEST['photo']);
$version  = isset($_REQUEST['ver']) ? pg_escape_string($_REQUEST['ver']) : FALSE;

$album_id = isset($_REQUEST['album']) ? pg_escape_string($_REQUEST['album']) : FALSE;

$photo_data  = pg_fetch_row(pg_query($database, "
  select location, caption, date_of_exposure, get_image_path(photo_version.identifier, 2) as preview_path, '' as original_path,
         access_rights, users, hide_original,
         title, author, '' as keyword, headline, caption_writer, caption,
         category, supplemental_category, credit, copyright_statement, web_statement,
         instructions, source, transmission_reference, 
	 photo_version.identifier, store_url, comments, folder
    from photo, photo_version
   where photo.identifier = photo_version.photo
     and photo_version.master = 't'
     and photo.identifier = '$photo_id'"));

$version = $photo_data[22];

/* Get any keywords for the photo... */
$res = pg_query($database, "select keyword from photo_keywords where photo=$photo_id");
$keywords = "";
for ($i=0; $i < pg_num_rows($res); $i++) {
  $dat = pg_fetch_assoc($res);
  $keywords .= "$dat[keyword]; ";
 }

$owner_id = $photo_data[6];

/* Ensure mere users don't move/mangle a photo that isn't theirs! */
if ($owner_id != $po_user['id'] && 
    $po_user['type'] != PO_USER_TYPE_ADMIN) {
  site_epilog($database);
  site_push_error($strings['errors']['not_owner']);
  header("Location: login.php");
  exit();
 }

$user_name = pg_fetch_row(pg_query($database, "select identifier, last_name, first_name from users where identifier=$owner_id"));

site_header($strings['import']['edit_photo']);
site_navigator(5);

$user_display_string = user_disp_string($owner_id, $po_user['id'], 
					$user_name[1], $user_name[2]);

$path_to_folder = get_path_to_folder($database, $photo_data[25]);
$title = get_photo_title($photo_data[10], $photo_data[1]);
site_navigator_status("$user_display_string $path_to_folder : <a href=\"photo.php?photo=$photo_id\">$title</a> : ".$strings['import']['edit_photo'], "");

print "&nbsp;<br/>\n";
print "<center>\n";
theme_display_photo("image.display.php?image=$photo_id&size=2&ver=$version", "", $image_repository_path . "/" . $photo_data[3]);
print "</center>\n";
print "&nbsp;<br/>\n";

$photo_tech = pg_fetch_row(pg_query($database, "select camera, lens, film, flash, scanner, filter, scan_resolution, aperture,
                                                       focal_length, shutter, camera_metering, camera_program, flash_mode,
                                                       exposure_comp, flash_comp, ev_difference, iso_override, support, scan_bitdepth, scan_multiscan, latitude, longitude, altitude, img_direction
                                                  from photo_tech where photo=$photo_id"));

print "<center>\n";

print "<form method=\"post\" action=\"photo.edit.2.php\" enctype=\"multipart/form-data\">\n";
print "<input type=\"hidden\" name=\"photo\" value=\"$photo_id\"/>\n";
print "<input type=\"hidden\" name=\"full_date_of_exposure\" value=\"$photo_data[2]\"/>\n";
if ($album_id) {
  print "<input type=\"hidden\" name=\"album\" value=\"$album_id\"/>\n";
 }

print "<table class=\"listing\">\n";

display_iptc_form($database, FALSE, 
		  $photo_data[8], $photo_data[9], $keywords, $photo_data[11],
		  $photo_data[12], $photo_data[13], $photo_data[14],
		  $photo_data[15], $photo_data[16], $photo_data[17],
		  $photo_data[18], $photo_data[18], $photo_data[20],
		  $photo_data[21], $photo_data[2], $photo_data[0],
		  $photo_data[5], $photo_data[7], $photo_data[23],
		  $photo_data[24]);

display_photo_tech_form($database, FALSE,
			$photo_tech[0], $photo_tech[10], $photo_tech[11], 
			$photo_tech[1], $photo_tech[8], $photo_tech[5],
			$photo_tech[2], $photo_tech[16], $photo_tech[7],
			$photo_tech[9], $photo_tech[13], $photo_tech[15],
			$photo_tech[3], $photo_tech[12], $photo_tech[14],
			$photo_tech[4], $photo_tech[6], $photo_tech[18],
			$photo_tech[19], $photo_tech[17], 
			$photo_tech[20], $photo_tech[21], $photo_tech[22],
			$photo_tech[23]);

print "</table>\n";
print $thm_elem['button.save.changes'];
print $thm_elem['button.clear'];
print $thm_elem['button.cancel'];
print "</form>\n";
print "</center>\n";

site_footer($database);
site_epilog($database);
?>
