<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/iptc.php";
include_once "include/orderby.php";
include_once "include/search.2.php";

function display_itemized_keyword_list($keywords) {
  global $thm_elem;

  foreach ($keywords as $keyword) {
    print "<input type=\"checkbox\" name=\"keywords[]\" value=\"$keyword\" />$keyword ";
  }
  print $thm_elem['button.search'];
}

$database = site_prolog();

$size = isset($_REQUEST['size']) ? pg_escape_string($_REQUEST['size']) : 2;

$photo_id = pg_escape_string($_REQUEST['photo']);
$version  = isset($_REQUEST['ver']) ? pg_escape_string($_REQUEST['ver']) : FALSE;
$album_id = isset($_REQUEST['album']) ? pg_escape_string($_REQUEST['album']) : FALSE;

$detail_info = isset($_REQUEST['detail_info']) ? $_REQUEST['detail_info'] : FALSE;
$order_by = $po_options['order_by'];
$my_rating = FALSE;

$album_data="";
$album_string="";

if ($photo_id || $version) {
  if (!$photo_id) {
    $photo_sel = "";
  } else {						
    if (is_numeric($photo_id))
      $photo_sel = "and photo.identifier = '$photo_id'";
    else
      $photo_sel = "and false is true";
  }

  /* select photo data */
  $version_selector = $version ? "photo_version.identifier=$version" : "photo_version.master='t'";
  $photo_data = pg_fetch_assoc(pg_query($database, "
    select photo.identifier, users, folder, location, caption, date_of_exposure, get_image_path(photo_version.identifier, $size) as preview_path, get_image_path(photo_version.identifier, 0) as original_path,
           photo.access_rights, copyright_statement, views,
           (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
           hide_original, author, title, 
           caption_writer, category, credit, source,
           headline, instructions, transmission_reference,
           supplemental_category, web_statement, colorspace, orientation, date_added,
          photo_version.identifier as version, photo.date_changed, store_url, photo.comments,
          can_access_photo(photo.identifier, $po_user[id], '{".$passwords."}') as ok
      from photo, photo_version
     where photo.identifier = photo_version.photo
       and $version_selector
           $photo_sel"));
 }

if (!$photo_data) {
  header("HTTP/1.1 404 Not found");
  site_header($strings['generic']['photo']);
  site_navigator(1);
  site_navigator_status(user_disp_string(0, $po_user['id'], "", ""). " : ". $strings['errors']['no_such_photo'], "");
  site_footer($database);
  site_epilog($database);
  exit();
}

if (!$photo_id) 
  $photo_id = $photo_data['identifier'];
if ($album_id)
  $album_string ="&amp;album=$album_id";

$version = $photo_data['version'];
$owner_id = $photo_data['users'];

if ($photo_data['ok'] != 't') {
  if ($photo_data['access_rights'] == $access['private']) {
    header("HTTP/1.1 403 Forbidden");
    site_header($strings['generic']['display_folder']);
    site_navigator(1);
    site_navigator_status(user_disp_string(0, $po_user['id'], "", ""). " : ". $strings['errors']['private'], "");
    site_footer($database);
    site_epilog($database);
    exit();
  } else {
    site_push_error($strings['errors']['protected']);
    header("Location: login.php?reason=protected&orig=".urlencode("photo.php?photo=$photo_id&ver=$version"));
  }
 }

$sql_folder_access_rights = "and can_access_folder(folder.identifier, $po_user[id], '{".$passwords."}')";
$sql_album_access_rights = "and can_access_album(album.identifier, $po_user[id], '{".$passwords."}')";

$sql_order_by_string = $order_by_string[$order_by][0];
if ($album_id) {
  $photos_in_container = pg_query($database, "
    select album_content.photo, album_content.version
      from album_content, photo, photo_version
     where album_content.album = $album_id
       and photo.identifier = album_content.photo
       and photo_version.identifier = album_content.version
       and can_access_photo(album_content.photo, $po_user[id], '{".$passwords."}')
     order by $sql_order_by_string");
} else {
  $photos_in_container = pg_query($database, "
    select photo.identifier, photo_version.identifier as version
      from photo, photo_version
     where photo.identifier = photo_version.photo
       and photo.folder = $photo_data[folder]
       and photo_version.master = 't'
       and can_access_photo(photo_version.photo, $po_user[id], '{".$passwords."}')
     order by $sql_order_by_string");
}

$next_idx = FALSE;
$prev_idx = FALSE;

for ($i=0; $i < pg_num_rows($photos_in_container); $i++) {  
  $tmp = pg_fetch_row($photos_in_container, $i);
  if (($album_id === FALSE && $tmp[0] == $photo_id) || 
      ($album_id && $tmp[1] == $version)) {
    if ($i+1 < pg_num_rows($photos_in_container)) {
      $next_idx = $i+1;
      $tmp = pg_fetch_row($photos_in_container, $next_idx);
      $next = $tmp[0];
      $next_ver = $tmp[1];  
    }
    if ($i-1 >= 0) {
      $prev_idx = $i-1;
      $tmp = pg_fetch_row($photos_in_container, $prev_idx);
      $prev = $tmp[0];
      $prev_ver = $tmp[1];  
    }
    break;
  }
 }

$user_data = pg_fetch_row(pg_query($database, "
   select users.identifier, last_name, first_name
     from users
    where users.identifier=$owner_id"));

$photo_tech = pg_fetch_row(pg_query($database, "
    select camera, lens, film, flash, scanner, filter, scan_resolution,
           aperture, focal_length, shutter, camera_metering, camera_program,
           flash_mode, exposure_comp, flash_comp, ev_difference, iso_override,
           support, scan_bitdepth, scan_multiscan, exif, iptc, 
           latitude, longitude, altitude, img_direction, rdf
      from photo_tech
     where photo=$photo_id"));

/* Get any keywords for the photo... */
$res = pg_query($database, "select keyword from photo_keywords where photo=$photo_id");
$keywords = FALSE;
for ($i=0; $i < pg_num_rows($res); $i++) {
  $dat = pg_fetch_assoc($res);
  $keywords[] = $dat['keyword'];
 }

if (!$detail_info)
  $detail_info = 1;

switch ($detail_info) {
case 1:
case 5:
case 6:
  /* Do nothing */
  break;
case 2:
case 3:
case 4:
case 98:
case 99:
  if (!(($po_user['id'] == $owner_id) || ($po_user['type'] == PO_USER_TYPE_ADMIN)))
     $detail_info = 1;
  break;
case 7:
  if (!$photo_data['copyright_statement'])
    $detail_info = 1;
  break;
default:
  $detail_info = 1;
}

if ($photo_data['title'] != "")
  $hdr_txt = "$photo_data[title] (# $photo_id)";
 elseif ($photo_data['caption'] != "")
  $hdr_txt = "$photo_data[caption] (# $photo_id)";
 else 
  $hdr_txt = $strings['generic']['photo'] . " # $photo_id (".$strings['photo']['no_title'].")";
   
site_header($hdr_txt);

$user_display_string = user_disp_string($owner_id, $po_user['id'], 
					$user_data[1], $user_data[2]);
if ($po_user['id'] == $owner_id) {
  site_navigator(5);
 } else {
  site_navigator(1);
 }

$zanza = strip_tags(get_photo_title($photo_data['caption'], $photo_data['title']), '<b><i><u>');
$folder_data = pg_fetch_row(pg_query($database, "
  select folder.identifier, folder.caption, folder.description
    from folder
   where folder.identifier=$photo_data[folder]
         $sql_folder_access_rights"));

$additional_info="";
$path_info = "";

if ($album_id) {
  $album_data = pg_fetch_row(pg_query($database, "
    select album.identifier, album.caption, album.description, album_content.date_added
      from album, album_content
     where album.identifier=$album_id
       and album_content.album = $album_id
       and album_content.photo = $photo_id
           $sql_album_access_rights"));
  if ($album_data[0]) {
    $path_to_album = get_path_to_album($database, $album_id);
    $path_info = $path_to_album . " : ". $zanza;    
  } else {
    $path_info = " : ".$strings['photo']['hidden_path'] ." : " . $zanza;
  }
  if ($folder_data[0])
    $additional_info=$strings['photo']['from_folder'] .": <a href=\"folder.php?folder=$folder_data[0]\">$folder_data[1]</a>&nbsp;";
 } else {
  if ($folder_data[0]) {
    $path_to_folder = get_path_to_folder($database, $folder_data[0]);
    $path_info = $path_to_folder . " : " . $zanza;
  } else {
    $path_info = " : ".$strings['photo']['hidden_path'] ." : " . $zanza;
  }
}

site_navigator_status("$user_display_string $path_info", $additional_info);

print "<div class=\"photo_preview\">";

print "<table width=\"100%\" class=\"photo_preview\" align=\"center\">\n<tr>\n";

print "<td align=\"center\" valign=\"middle\" height=\"25\" width=\"29\">\n";
if ($prev_idx !== FALSE) {
  print "<div class=\"hide_tooltip\" id=\"prev_tip\">";
  print "<img src=\"image.display.php?image=$prev&amp;ver=$prev_ver&amp;size=1\" alt=\"$prev_ver\"/>";
  print "</div>\n";
  $on_mouse_over ="TagToTip('prev_tip', OFFSETX, 12, ABOVE, true);";
  print sprintf($thm_elem['button.previous'], 
		"photo.php?photo=$prev&amp;ver=$prev_ver&amp;detail_info=$detail_info$album_string", 
		$strings['generic']['photo'],
		"onmouseover=\"$on_mouse_over\"");
 }
print "</td>\n";
print "<td align=\"center\" valign=\"middle\">\n";

if (grant_access_to_original($photo_data['original_path'] != "",
                             ($po_user['id'] == $owner_id),
			     ($po_user['type'] == PO_USER_TYPE_ADMIN),
                             $photo_data['hide_original'] == "f")) {
  theme_display_photo("image.display.php?image=$photo_id&amp;size=$size&amp;ver=$version", "image.display.php?image=$photo_id&amp;size=0&amp;ver=$version", $image_repository_path . "/" . $photo_data['preview_path']);
} else {
  theme_display_photo("image.display.php?image=$photo_id&amp;size=$size&amp;ver=$version", "", $image_repository_path . "/" . $photo_data['preview_path']);
}
print "</td>";
print "<td align=\"center\" valign=\"middle\" height=\"25\" width=\"29\">\n";
if ($next_idx !== FALSE) {
  print "<div class=\"hide_tooltip\" id=\"next_tip\">";
  print "<img src=\"image.display.php?image=$next&amp;ver=$next_ver&amp;size=1\" alt=\"$next_ver\" />";
  print "</div>\n";
  $on_mouse_over ="TagToTip('next_tip', OFFSETX, 12, ABOVE, true, LEFT, true);";

  print sprintf($thm_elem['button.next'], 
		"photo.php?photo=$next&amp;ver=$next_ver&amp;detail_info=$detail_info$album_string", 
		$strings['generic']['photo'],
		"onmouseover=\"$on_mouse_over\"");
}
print "</td>\n";
print "</tr>\n</table>";
print "</div>";

print "<div class=\"navigatorf\">";
print "<ul>";
if ($detail_info == 1) {
  $here = "class=\"menu_here\" ";
 } else {
  $here = "";
 }

print "<li $here><a $here href=\"photo.php?photo=$photo_id&amp;ver=$version&amp;detail_info=1$album_string\">".$strings['photo']['details']."</a></li>";

if (($po_user['id'] == $owner_id) || ($po_user['type'] == PO_USER_TYPE_ADMIN)) {

  if ($detail_info == 2 || $detail_info == 98 || $detail_info == 99) {
    $here = "class=\"menu_here\" ";
  } else {
    $here = "";
  }
  print "<li $here><a $here href=\"photo.php?photo=$photo_id&amp;ver=$version&amp;detail_info=2$album_string\">".$strings['photo']['technical']."</a></li>";
 }

if ($detail_info == 5) {
  $here = "class=\"menu_here\" ";
 } else {
  $here = "";
 }

print "<li $here><a $here href=\"photo.php?photo=$photo_id&amp;ver=$version&amp;detail_info=5$album_string\">".$strings['photo']['versions']."</a></li>";

if (($po_user['id'] == $owner_id) || ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
  if ($detail_info == 3) {
    $here = "class=\"menu_here\" ";
  } else {
    $here = "";
  }
    print "<li $here><a $here href=\"photo.php?photo=$photo_id&amp;ver=$version&amp;detail_info=3$album_string\">".$strings['photo']['dupes']."</a></li>";

 }

if ($detail_info == 6) {
  $here = "class=\"menu_here\" ";
 } else {
  $here = "";
 }

print "<li $here><a $here href=\"photo.php?photo=$photo_id&amp;ver=$version&amp;detail_info=6$album_string\">".$strings['photo']['ratings']."</a></li>";

if ($photo_data['copyright_statement']) {
  if ($detail_info == 7) {
    $here = "class=\"menu_here\" ";
  } else {
    $here = "";
  }
  print "<li $here><a $here href=\"photo.php?photo=$photo_id&amp;ver=$version&amp;detail_info=7$album_string\">".$strings['photo']['copyright']."</a></li>";
}

print "</ul>";
print "</div>";

print "<div>";

print "<form method=\"post\" action=\"photo.move.php\">\n";
print "<input type=\"hidden\" name=\"source_album\" value=\"$album_id\" />\n";
print "<input type=\"hidden\" name=\"photo_id\" value=\"$photo_id\" />\n";
print "<input type=\"hidden\" name=\"version\" value=\"$version\" />\n";
print "<input type=\"hidden\" name=\"owner_id\" value=\"$owner_id\" />\n";
if ($album_id) {
  print "<input type=\"hidden\" name=\"album\" value=\"$album_id\"/>\n";
 }
switch ($detail_info) {
  default:
  case 1:
    print "<table class=\"listing\" cellspacing=\"1\" cellpadding=\"4\">\n";
    print "<tr>".emit_td($strings['photo']['identifier']);
    print "<td>$photo_id</td></tr>\n";
    if ($photo_data['title'] != "") {
      print "<tr>".emit_td($strings['generic']['title']);
      print "<td>$photo_data[title]</td></tr>\n";
    }
    if ($photo_data['author'] != "") {
      print "<tr>".emit_td($strings['generic']['author']);
      print "<td>$photo_data[author]</td></tr>\n";
    }
    if ($keywords != FALSE) {
      print "<tr>".emit_td($strings['generic']['keywords']);
      print "<td>";
      display_itemized_keyword_list($keywords);
      print "</td></tr>\n";
    }

    if ($photo_data['headline'] != "") {
      print "<tr>".emit_td($strings['generic']['headline']);
      print "<td>$photo_data[headline]</td></tr>\n";
    }
    if ($photo_data['credit'] != "") {
      print "<tr>".emit_td($strings['generic']['credit']);
      print "<td>$photo_data[credit]</td></tr>\n";
    }

    if ($photo_data['caption_writer'] != "") {
      print "<tr>".emit_td($strings['generic']['caption_writer']);
      print "<td>$photo_data[caption_writer]</td></tr>\n";
    }
    if ($photo_data['caption'] != "") {
      print "<tr>".emit_td($strings['generic']['caption']);
      print "<td>$photo_data[caption]</td></tr>\n";
    }
    if ($photo_data['comments'] != "") {
      print "<tr>".emit_td($strings['generic']['remark']);
      print "<td>$photo_data[comments]</td></tr>\n";
    }
    if ($album_id && ($album_data[2] != "")) {
      print "<tr>".emit_td($strings['photo']['album_descr']);
      print "<td>$album_data[2]</td></tr>\n";
    } 
    if ($folder_data[2] != "") {
      print "<tr>".emit_td($strings['photo']['folder_descr']);
      print "<td>$folder_data[2]</td></tr>\n";
    }
    if ($photo_data['category'] != "") {
      print "<tr>".emit_td($strings['generic']['category']);
      print "<td>$photo_data[category]</td></tr>\n";
    }
    if ($photo_data['supplemental_category'] != "") {
      print "<tr>".emit_td($strings['generic']['supp_category']);
      print "<td>$photo_data[supplemental_category]</td></tr>\n";
    }
    if ($photo_data['source'] != "") {
      print "<tr>".emit_td($strings['generic']['source']);
      print "<td>$photo_data[source]</td></tr>\n";
    }
    if ($photo_data['instructions'] != "") {
      print "<tr>".emit_td($strings['generic']['instructions']);
      print "<td>$photo_data[instructions]</td></tr>\n";
    }
    if ($photo_data['transmission_reference'] != "") {
      print "<tr>".emit_td($strings['generic']['trans_reference']);
      print "<td>$photo_data[transmission_reference]</td></tr>\n";
    }

    if ($photo_data['location']) {
      $location = pg_fetch_assoc(pg_query($database, "select place, city, state, country from view_location where identifier=$photo_data[location]"));
      if ($location['place'] != "" && ($location['city'] != "" || $location['state'] != "" || $location['country'] != "")) { $location['place'] .= ","; }
      if ($location['city'] != "" && ($location['state'] != "" || $location['country'] != "")) { $location['city'] .= ","; }
      if ($location['state'] != "" && ($location['country'] != "")) { $location['state'] .= ","; }
      print "<tr>".emit_td($strings['generic']['location']);
      print emit_td("$location[place] $location[city] $location[state] $location[country]");
      print "</tr>\n";
    }

    /* Knock off the seconds for each */
    if ($photo_data['date_of_exposure'])
      $photo_data['date_of_exposure'] = substr($photo_data['date_of_exposure'], 0, 16) . ":00";

    if ($photo_data['date_of_exposure'])
      $photo_data['date_added'] = substr($photo_data['date_added'], 0, 16) . ":00";

    if ($photo_data['date_changed'])
      $photo_data['date_changed'] = substr($photo_data['date_changed'], 0, 16) . ":00";

    if ($photo_data['date_of_exposure'] != "") {
      print "<tr>".emit_td($strings['generic']['exposed']);
      print "<td>";
      if (substr($photo_data['date_of_exposure'], 11, 8) != "00:00:00") {
        print emit_date_html($photo_data['date_of_exposure'], "full");
      } else {
        print emit_date_html($photo_data['date_of_exposure'], "date");
      }
      print "</td></tr>\n";
    }
    if (($photo_data['date_added'] != "") && ($photo_data['date_added'] != $photo_data['date_of_exposure'])) {
      print "<tr>".emit_td($strings['generic']['imported']);
      print "<td>";
      if (substr($photo_data['date_added'], 11, 8) != "00:00:00") {
        print emit_date_html($photo_data['date_added'], "full");
      } else {
        print emit_date_html($photo_data['date_added'], "date");
      }
      print "</td></tr>\n";
    }
    if (($photo_data['date_changed'] != "") && 
	($photo_data['date_changed'] != $photo_data['date_of_exposure']) &&
	($photo_data['date_changed'] != $photo_data['date_added'])) {
      print "<tr>".emit_td($strings['generic']['changed']);
      print "<td>";
      if (substr($photo_data['date_changed'], 11, 8) != "00:00:00") {
        print emit_date_html($photo_data['date_changed'], "full");
      } else {
        print emit_date_html($photo_data['date_changed'], "date");
      }
      print "</td></tr>\n";
    }

    if ($album_id && ($album_data[3] != "") && ($album_data[3] != $photo_data['date_added'])) {
      print "<tr>".emit_td($strings['photo']['album_added']);
      print "<td>";
      print emit_date_html($album_data[3], "full");
      print "</td></tr>\n";
    } 

    $result = pg_query($database, "select album.identifier as identifier, album.caption as description, album_content.date_added from album, album_content where album_content.album = album.identifier and album_content.photo = $photo_id $sql_album_access_rights");
    if (pg_num_rows($result) > 0) {
      print "<tr>".emit_td($strings['photo']['albums']);
      print "<td>";
      print "<ul>";
      for ($i = 0 ; $i < pg_num_rows($result); $i++) {
	$row = pg_fetch_assoc($result);
	print "<li>". emit_a("album.php?album=$row[identifier]", $row['description'])." [". emit_date_html($row['date_added'], "full")."]</li>";
      }
      print "</ul>";
      print "</td></tr>\n";
    }


    if ($photo_data['access_rights'] != "") {
      print "<tr>".emit_td($strings['generic']['access']);
      print "<td>" . $strings['generic'][$access[$photo_data['access_rights']]];
      if ($photo_data['hide_original'] == "f")
        print ", ".$strings['generic']['access_auth_users'];
      else
        print ", ".$strings['generic']['access_owner_only'];
      print "</td></tr>\n";
    }
    if ($photo_data['views'] != "") {
      print "<tr>".emit_td($strings['generic']['views']);
      print "<td>$photo_data[views]</td></tr>\n";
    }
    if ($photo_data['store_url'] != "") {
      print "<tr>".emit_td($strings['photo']['purchase']);
      print "<td><a href=\"$photo_data[store_url]\">$photo_data[store_url]</a></td></tr>\n";
    }
    print "</table>\n";
    break;
 case 2:
    if ($photo_tech[0]!="")  $camera  = pg_fetch_row(pg_query($database, "select name, model, variation from view_camera  where identifier=$photo_tech[0]"));
    if ($photo_tech[1]!="")  $lens    = pg_fetch_row(pg_query($database, "select name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length from view_lens  where identifier=$photo_tech[1]"));
    if ($photo_tech[2]!="")  $film    = pg_fetch_row(pg_query($database, "select name, model, iso, format from view_film  where identifier=$photo_tech[2]"));
    if ($photo_tech[3]!="")  $flash   = pg_fetch_row(pg_query($database, "select name, model, variation from view_flash   where identifier=$photo_tech[3]"));
    if ($photo_tech[4]!="")  $scanner = pg_fetch_row(pg_query($database, "select name, model, variation from view_scanner where identifier=$photo_tech[4]"));
    if ($photo_tech[5]!="")  $filter  = pg_fetch_row(pg_query($database, "select name, model, variation from view_filter  where identifier=$photo_tech[5]"));
    if ($photo_tech[17]!="") $support = pg_fetch_row(pg_query($database, "select name, model, variation from view_support where identifier=$photo_tech[17]"));
    if ($photo_tech[9]!="")  $shutter         = pg_fetch_row(pg_query($database, "select value from shutter         where identifier=$photo_tech[9]"));
    if ($photo_tech[8]!="")  $focal_length    = $photo_tech[8];
    if ($photo_tech[13]!="") $exposure_comp   = pg_fetch_row(pg_query($database, "select value from ev_comp         where identifier=$photo_tech[13]"));
    if ($photo_tech[15]!="") $ev_difference   = pg_fetch_row(pg_query($database, "select value from ev_comp         where identifier=$photo_tech[15]"));
    if ($photo_tech[10]!="") $camera_metering = pg_fetch_row(pg_query($database, "select value from camera_metering where identifier=$photo_tech[10]"));
    if ($photo_tech[11]!="") $camera_program  = pg_fetch_row(pg_query($database, "select value from camera_program  where identifier=$photo_tech[11]"));
    if ($photo_tech[12]!="") $flash_mode      = pg_fetch_row(pg_query($database, "select value from flash_mode      where identifier=$photo_tech[12]"));
    if ($photo_tech[14]!="") $flash_comp      = pg_fetch_row(pg_query($database, "select value from ev_comp         where identifier=$photo_tech[14]"));
    if ($photo_tech[16]!="") $iso_override    = pg_fetch_row(pg_query($database, "select value from film_iso        where identifier=$photo_tech[16]"));

    if ($photo_tech[6]!="")  $scan_resolution = $photo_tech[6];
    if ($photo_tech[18]!="") $scan_bitdepth   = $photo_tech[18];
    if ($photo_tech[19]!="") $scan_multiscan  = $photo_tech[19];

    print "<table class=\"listing\">\n";
    if ($photo_tech[0]!="") {
      print "<tr>".emit_td($strings['generic']['camera']);
      print "<td>$camera[0] $camera[1] $camera[2]</td></tr>\n";
    }
    if ($photo_tech[10]!="") {
      print "<tr>".emit_td($strings['generic']['camera_metering']);
      print "<td>$camera_metering[0]</td></tr>\n";
    }
    if ($photo_tech[11]!="") {
      print "<tr>".emit_td($strings['generic']['camera_program']);
      print "<td>$camera_program[0]</td></tr>\n";
    }
    if ($photo_tech[1]!="") {
      print "<tr>".emit_td($strings['generic']['lens']);
      print "<td>$lens[0] $lens[1] $lens[2] ";
      print emit_lens_string($lens[3], $lens[4], $lens[5], $lens[6]);
      print "</td></tr>\n";
    }
    if ($photo_tech[8]!="") {
      print "<tr>".emit_td($strings['generic']['focal_length']);
      print "<td>$photo_tech[8] mm</td></tr>\n";
    }
    if ($photo_tech[5]!="") {
      print "<tr>".emit_td($strings['generic']['filter']);
      print "<td>$filter[0] $filter[1] $filter[2]</td></tr>\n";
    }
    if ($photo_tech[2]!="") {
      print "<tr>".emit_td($strings['generic']['film']);
      print "<td>$film[0] $film[1]";
      if ($film[2]!="") {
        print " ISO $film[2]";
      }
      if ($film[3]!="") print ", $film[3]";
      print "</td></tr>\n";
      if ($photo_tech[16]!="") {
	print "<tr>";
	print emit_td($strings['generic']['iso_override']);
	print emit_td($iso_override[0]);
	print "</tr>";
      }
    } else if ($photo_tech[16]!="") {
      print emit_td($strings['profile']['iso']);
      print emit_td($iso_override[0]);
    }
    if ($photo_tech[7]!="") {
      print "<tr>".emit_td($strings['generic']['aperture']);
      print "<td>$photo_tech[7]</td></tr>\n";
    }
    if ($photo_tech[9]!="") {
      print "<tr>".emit_td($strings['generic']['shutter_speed']);
      print "<td>$shutter[0]s</td></tr>\n";
    }
    if ($photo_tech[13]!="" && $exposure_comp[0] != 0) {
      print "<tr>".emit_td($strings['generic']['exp_comp']);
      print "<td>$exposure_comp[0]</td></tr>\n";
    }
    if ($photo_tech[15]!="" && $ev_difference[0] != 0) {
      print "<tr>".emit_td($strings['generic']['exp_diff']);
      print "<td>$ev_difference[0]</td></tr>\n";
    }
    if ($photo_tech[3]!="") {
      print "<tr>".emit_td($strings['generic']['flash']);
      print "<td>$flash[0] $flash[1] $flash[2]</td></tr>\n";
    }
    if ($photo_tech[12]!="") {
      print "<tr>".emit_td($strings['generic']['flash_mode']);
      print "<td>$flash_mode[0]</td></tr>\n";
    }
    if ($photo_tech[14]!="" && $flash_comp[0] != 0) {
      print "<tr>".emit_td($strings['generic']['flash_comp']);
      print "<td>$flash_comp[0]</td></tr>\n";
    }
    if ($photo_tech[4]!="") {
      print "<tr>".emit_td($strings['generic']['scanner']);
      print "<td>$scanner[0] $scanner[1] $scanner[2]</td></tr>\n";
    }
    if ($photo_tech[6]!="") {
      print "<tr>".emit_td($strings['generic']['scan_parameters']);
      print "<td>";
      if ($scan_resolution!="") print "$scan_resolution ".$strings['generic']['dpi'] ."&nbsp;\n";
      if ($scan_bitdepth!="") print "$scan_bitdepth ". $strings['generic']['bits'] ."&nbsp;";
      if ($scan_multiscan!="") print "$scan_multiscan " .$strings['generic']['passes'];
      print "</td></tr>\n";
    }

    /* colorspace data */
    if ($photo_data['colorspace']!="") {
      global $icc_profiles;
      $photo_data['colorspace'] = $icc_profiles[$photo_data['colorspace']]['name'];
      print "<tr>".emit_td($strings['generic']['colorspace']);
      print "<td>$photo_data[colorspace]</td></tr>\n";
    }

    /* orientation data */
    if ($photo_data['orientation'] != "") {
      $photo_data['orientation'] = orientation_to_name($database, $photo_data['orientation']);
      print "<tr>".emit_td($strings['generic']['rotation']);
      print "<td>$photo_data[orientation]</td></tr>\n";
    }

    if ($photo_tech[17]!="") {
      print "<tr>".emit_td($strings['generic']['support']);
      print "<td>$support[0] $support[1] $support[2]</td></tr>\n";
    }
    /* GPS Data */
    if ($photo_tech[22] != "") {
      $photo_tech[23] = latitude_dms($photo_tech[23], "longitude");
      $photo_tech[22] = latitude_dms($photo_tech[22], "latitude");
      print "<tr>".emit_td($strings['generic']['location']);
      print emit_td($strings['photo']['latitude'] . ": $photo_tech[22]<br/>".$strings['photo']['longitude'] .": $photo_tech[23]<br/> ".$strings['photo']['altitude'].": $photo_tech[24] m");
      if ($photo_tech[25] != "") {
	print "<tr>".emit_td($strings['photo']['direction'] .": $photo_tech[25]");
      }
      print "</td></tr>\n";
    }
    
    if ($photo_tech) {
      print "<tr><td><a href=\"photo.php?photo=$photo_id&amp;detail_info=98$album_string\">".$strings['photo']['full_exif']."</a></td>";
      print "<td> </td></tr>\n";
    }
    print "<tr><td><a href=\"photo.php?photo=$photo_id&amp;detail_info=99$album_string\">".$strings['photo']['full_exif_dump']."</a></td>";
    print "<td> </td></tr>\n";

    print "</table>\n";
    break;
 case 98:
    print "<table class=\"listing\">\n";

    /* custom exif data */
    if ($photo_tech[20]!="") {
      $trans = array("<key>" => "<tr><td><i>",
                     "</key><value>" => "</i></td><td>",
                     "</value>" => "</td></tr>\n");
      print "<tr><td><strong>EXIF</strong></td><td></td></tr>";
      print strtr($photo_tech[20], $trans);
    }
    /* iptc data */
    if ($photo_tech[21]!="") {
      $trans = array("<key>" => "<tr><td><i>",
                     "</key><value>" => "</i></td><td>",
                     "</value>" => "</td></tr>\n");
      print "<tr><td><strong>IPTC</strong></td><td></td></tr>";
      print strtr($photo_tech[21], $trans);
    }
    /* xmp/rdf data */
    if ($photo_tech[26]!="") {
      $trans = array("<key>" => "<tr><td><i>",
                     "</key><value>" => "</i></td><td>",
                     "</value>" => "</td></tr>\n");
      print "<tr><td><strong>XMP/RDF</strong></td><td></td></tr>";
      print strtr($photo_tech[26], $trans);
    }
    print "<tr><td><a href=\"photo.php?photo=$photo_id&amp;detail_info=99$album_string\">".$strings['photo']['full_exif_dump']."</a></td>";
    print "<td> </td></tr>\n";
    print "</table>\n";
    break;
 case 99:
   $image_path = $image_repository_path . "/" . $photo_data['original_path'];

   print "<table class=\"listing\">\n";

   if (is_executable($sys_exiftool)) {
     $handle = popen("$sys_exiftool $image_path", "r");
     if ($handle) {
       while (!feof($handle)) {
	 $line = fgets($handle);
	 $parts = explode(":", $line, 2);
	 $parts[0] = trim($parts[0]);
	 if (!isset($parts[1])) continue;
	 $parts[1] = trim($parts[1]);
	 if ($parts[0] == "File Name") continue;
	 if ($parts[0] == "Directory") continue;
	 if (substr($parts[1], 2, 6) == "Binary") continue;
       print "<tr><td><i>$parts[0]</i></td><td>$parts[1]</td></tr>\n";
       }
       pclose($handle);
     }
   } else {
     include('include/exif.php');
     
     $exif2 = read_exif_data_raw($image_path, 0);

     foreach ($exif2 as $key => $section) {
       if (is_array($section)) {
	 foreach ($section as $name => $val) {
	   if (!(strpos($name, 'unknown') === false)) continue;
	   if (!(strpos($name, 'RAWDATA') === false)) continue;
	   if (is_array($val)) {
	     foreach ($val as $name2 => $val2) {
	       if (!(strpos($name2, 'unknown') === false)) continue;
	       if (!(strpos($name2, 'RAWDATA') === false)) continue;
	       if (is_array($val2)) {
		 foreach ($val2 as $name3 => $val3) {
		   if (!(strpos($name3, 'unknown') === false)) continue;
		   if (!(strpos($name3, 'RAWDATA') === false)) continue;
		   print "<tr><td>$key.$name.$name2.$name3</td>";
		   print "<td>$val3</td></tr>\n";
		 }
	       } else {
		 print "<tr><td>$key.$name.$name2</td>";
		 print "<td>$val2</td></tr>\n";
	       }
	     }
	   } else {
	     print "<tr><td>$key.$name</td>";
	     print "<td>$val</td></tr>\n";
	   }
	 }
       } else {
	 print "<tr><td>$key</td>";
	 print "<td>$section</td></tr>\n";
       }
     }
   }
   print "</table>\n";


   break;
  case 3:
    $all_photo_dupes = pg_query($database, "
      select photo_dupe.identifier, key, date_of_creation, storage_location, storage_index, remark, version
        from photo_dupe
       where photo=$photo_id
       order by key asc");
    print "<table class=\"folder\">\n";
    print "<tr class=\"header\">\n";
    print emit_th($strings['photo']['dupe_id'], "width=\"10%\"");
    print emit_th($strings['generic']['version'], "width=\"10%\"");
    print emit_th($strings['generic']['created'], "width=\"10%\"");
    print emit_th($strings['import']['storage_location'], "width=\"10%\"");
    print emit_th($strings['generic']['remark'], "width=\"40%\"");
    print "<th width=\"10%\" colspan=\"2\"><a href=\"photo.dupe.php?action=add&amp;photo=$photo_id&amp;version=$version\">".$strings['photo']['add_dupe']."</a></th>\n";
    print "</tr>\n";
    for ($i=0; $i < pg_num_rows($all_photo_dupes); $i++) {
      $photo_dupe = pg_fetch_row($all_photo_dupes, $i);
      print "<tr>\n";
      print "<td>$photo_id-$photo_dupe[1]</td>";
      print "<td>";
      print "<div class=\"hide_tooltip\" id=\"dupe_tip_$i\">";
      print "<img src=\"image.display.php?image=$photo_id&amp;size=1&amp;ver=$photo_dupe[6]\" alt=\"\" />";
      print "</div>\n";
      $on_mouse_over ="TagToTip('dupe_tip_$i', OFFSETX, 12);";
      print "<a href=\"photo.php?photo=$photo_id&amp;detail_info=5&amp;ver=$photo_dupe[6]$album_string\" onmouseover=\"$on_mouse_over\">$photo_dupe[6]</a></td>";
      print "<td>".emit_date_html($photo_dupe[2], 'date')."</td>";
      if ($photo_dupe[3] != 'null') {
	if ($photo_dupe[4])
	  print "<td>$photo_dupe[3]-$photo_dupe[4]</td>";
	else
	  print "<td>$photo_dupe[3]</td>";
      } else {
	print "<td></td>";
      }
      print "<td>$photo_dupe[5]</td>";
      print "<td width=\"5%\">";
      print "<a href=\"photo.dupe.php?action=edit&amp;dupe=$photo_dupe[0]\">".$strings['generic']['edit']."</a></td>\n";
      print "<td width=\"5%\">";
      if ($photo_dupe[5] != "Original")
	print "<a href=\"photo.dupe.php?action=delete&amp;dupe=$photo_dupe[0]\">".$strings['generic']['delete']."</a>";
      print "</td>\n";
      print "</tr>\n";
    }
    print "</table>\n";
    break;
  case 5:
    $photo_versions = pg_query($database, "
      select photo_version.identifier, key, date_of_creation, comment, 
             original_image_name, 
             date_changed, master, path, x_res, y_res, filesize
        from photo_version, files
       where photo=$photo_id 
         and files.version = photo_version.identifier
         and files.size = 0
    order by master desc, key asc");

    print "<table class=\"folder\">\n";
    print "<tr class=\"header\">\n";
    print emit_th($strings['generic']['version'], "width=\"5%\"");
    print emit_th($strings['generic']['created'], "width=\"10%\"");
    print emit_th($strings['generic']['changed'], "width=\"10%\"");
    print emit_th($strings['generic']['master'], "width=\"5%\"");
    print emit_th($strings['generic']['remark'], "width=\"40%\"");
    print emit_th($strings['generic']['orig_file'], "width=\"10%\"");
    print emit_th($strings['photo']['dimensions'], "width=\"6%\"");
    print emit_th($strings['generic']['size'], "width=\"5%\"");

    if (($po_user['id'] == $owner_id) || ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
      print "<th width=\"10%\" colspan=\"2\"><a href=\"photo.version.php?action=add&amp;photo=$photo_id$album_string\">".$strings['photo']['add_version']."</a></th>\n";
    }
    print "</tr>\n";

    for ($i=0; $i < pg_num_rows($photo_versions); $i++) {
      $photo_version = pg_fetch_row($photo_versions, $i);
      $row_cls = $photo_version[0] == $version ? "class=\"emphasis\"" : "";
      print "<tr $row_cls>\n";
      print "<td>";
      print "<div class=\"hide_tooltip\" id=\"ver_tip_$i\">";
      print "<img src=\"image.display.php?image=$photo_id&amp;size=1&amp;ver=$photo_version[0]\" alt=\"\" />";
      print "</div>\n";
      $on_mouse_over ="TagToTip('ver_tip_$i', OFFSETX, 12);";
      print "<a href=\"photo.php?photo=$photo_id&amp;detail_info=5&amp;ver=$photo_version[0]$album_string\" onmouseover=\"$on_mouse_over\">$photo_id-V$photo_version[1]</a></td>";
      print "<td>".emit_date_html($photo_version[2], 'date')."</td>";
      print "<td>".emit_date_html($photo_version[5], 'date')."</td>";
      print "<td>".emit_yes_no_text($photo_version[6])."</td>";
      print "<td>$photo_version[3]</td>";
      print "<td>$photo_version[4]</td>";

      $image_size = $photo_version[10] / 1024;
      if ($image_size < 1024) {
        $image_size = round($image_size);
        $image_size_string = "$image_size KB";
      } else {
        $image_size /=1024;
        $image_size = round($image_size);
        $image_size_string = "$image_size MB";
      }

      print "<td>$photo_version[8]x$photo_version[9]</td>";
      print "<td>$image_size_string</td>";

    if (($po_user['id'] == $owner_id) || ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
      print "<td width=\"5%\">";
      print "<a href=\"photo.version.php?action=edit&amp;photo=$photo_id&amp;version=$photo_version[0]$album_string\">".$strings['generic']['edit']."</a>";
      print "</td>\n";
      print "<td width=\"5%\">";
      if ($photo_version[6] != 't') {
	print "<a href=\"photo.version.php?action=delete&amp;photo=$photo_id&amp;version=$photo_version[0]$album_string\">".$strings['generic']['delete']."</a>\n";
      }
      print "</td>\n";
    }
      print "</tr>\n";
    }
    print "</table>\n";
    break;
  case 6:
    $average_rating = pg_fetch_row(pg_query($database, "select avg(value) from rating where photo=$photo_id"));
    if ($average_rating[0] == "") {
      $average_rating = "";
    } else {
      $average_rating = round($average_rating[0], 2);
    }
    print "<table class=\"folder\">\n";
    print "<tr class=\"header\">\n";
    print "<th width=\"10%\">".$strings['generic']['rating'];
    if ($average_rating != "")
      print ": <b>$average_rating</b>";
    print "</th>";
    print emit_th($strings['generic']['version'], "width=\"10%\"");
    print emit_th($strings['generic']['remark'], "width=\"40%\"");
    print emit_th($strings['generic']['user'], "width=\"15%\"");
    print emit_th($strings['generic']['created'], "width=\"15%\"");
    print emit_th($po_user['id'] ? "<a href=\"photo.rating.php?action=add&amp;photo=$photo_id&amp;version=$version$album_string\">".$strings['generic']['rate']."</a>\n" : "", "width=\"10%\" colspan=\"2\"");
    print "</tr>\n";

    if ($po_user['id']) {
      $result = pg_query($database, "
        select identifier, date_of_creation, value, comment, version
          from rating
         where photo = $photo_id
           and users = $po_user[id] order by date_of_creation");
      for ($i = 0 ; $i < pg_num_rows($result) ; $i++) {
	$my_rating = pg_fetch_row($result);
	print "<tr>\n";
	print "<td>$my_rating[2]</td>";
	print "<td>";
	print "<div class=\"hide_tooltip\" id=\"rate_tip_$i\">";
	print "<img src=\"image.display.php?image=$photo_id&amp;size=1&amp;ver=$my_rating[4]\" alt=\"\" />";
	print "</div>\n";
	$on_mouse_over ="TagToTip('rate_tip_$i', OFFSETX, 12);";
	print "<a href=\"photo.php?photo=$photo_id&amp;detail_info=5&amp;ver=$my_rating[4]$album_string\" onmouseover=\"$on_mouse_over\">$photo_id-$my_rating[4]</a></td>";
	print "<td>$my_rating[3]</td>";
	print "<td><a href=\"user.php?user=$po_user[id]\">".$strings['photo']['myself']."</a></td>";
	print "<td>".emit_date_html($my_rating[1], 'date')."</td>";
	if ($po_user['id']!="") {
	  print "<td width=\"5%\">";
	  print "<a href=\"photo.rating.php?action=edit&amp;rating=$my_rating[0]$album_string\">".$strings['generic']['edit']."</a></td>\n";
	  print "<td width=\"5%\">";
	  print "<a href=\"photo.rating.php?action=delete&amp;rating=$my_rating[0]$album_string\">".$strings['generic']['delete']."</a></td>\n";
	}
	print "</tr>\n";
      }
    }

    $all_ratings = pg_query($database, "
      select identifier, users, date_of_creation, value, first_name, last_name, comment, version
        from view_rating
       where photo=$photo_id
       order by date_of_creation");
    if ($all_ratings) {
      for ($i=0; $i < pg_num_rows($all_ratings); $i++) {
	$rating = pg_fetch_row($all_ratings, $i);
	if ($rating[1] == $po_user['id'])
	  continue;
	print "<tr>\n";
	print "<td>$rating[3]</td>";
	print "<td>$rating[7]</td>";
	print "<td>$rating[6]</td>";
	print "<td><a href=\"user.php?user=$rating[1]\">$rating[4] $rating[5]</a></td>";
	print "<td>".emit_date_html($rating[2], 'date')."</td>";
	print "<td></td>\n";
	print "<td></td>\n";
	print "</tr>\n";
      }
    print "</table>\n";

    }
    break;
 case 7:
    if (strncmp($photo_data['web_statement'], "http", 4) == 0)
      $photo_data['web_statement'] = "<a href=\"".$photo_data['web_statement']."\">".$photo_data['web_statement']."</a>";

    print "<table class=\"listing\">\n";
    print "<tr>".emit_td($strings['generic']['copyright']);
    print "<td>$photo_data[copyright_statement]</td></tr>\n";
    print "<tr>".emit_td($strings['generic']['web_statement']);
    print "<td>$photo_data[web_statement]</td></tr>\n";
    print "</table>\n";
    break;
 }

/************************* Now for the page footer *************************/

print "<div class=\"actions\">";
print "<input type=\"hidden\" name=\"detail_info\" value=\"$detail_info\" />";

display_order_by_combo_with_button($order_by);

if ($po_user['id'] == $owner_id || $po_user['type'] == PO_USER_TYPE_ADMIN) {
  display_transform($photo_id);
 }

print "<table><tr><td>";

if ($po_user['id'] == $owner_id || $po_user['type'] == PO_USER_TYPE_ADMIN) {
  print sprintf($thm_elem['button.edit'], "photo.edit.php?photo=$photo_id$album_string");

  if ($photo_data['folder'] != $po_user['trash_folder'])
    print $thm_elem['button.delete_s'];
 }

if ($po_user['type'] > PO_USER_TYPE_CLIENT) {
  print $thm_elem['button.set.as.watermark'];
 } 

if ($po_user['type'] >= PO_USER_TYPE_CLIENT) {
  print $thm_elem['button.add.to.spool'];
 }
print "</td></tr></table>\n";

if ($po_user['id'] == $owner_id || $po_user['type'] == PO_USER_TYPE_ADMIN) {
  $folder_all = get_users_folder($database);
  display_folder_actions($folder_all, $photo_data['folder']);
 }

if ($po_user['type'] >= PO_USER_TYPE_CLIENT) {
  $album_all = get_users_album($database);
  if (pg_num_rows($album_all) > 0) {
    display_album_actions($album_all, $album_id);
  }
  display_spool_actions($database, $po_user['id']);
 }

print "</div>";

print "</form>\n";
print "</div>";

site_footer($database);
site_epilog($database);
?>
