<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


include_once "include/config.php";
include_once "include/site.php";
include_once "include/search.2.php";

$database = site_prolog(PO_USER_TYPE_USER);

if ($po_user['type'] == PO_USER_TYPE_ADMIN) {
  $owner_id = pg_escape_string($_REQUEST['user']);
  $folder_id = "(select identifier from folder where users = $owner_id and caption = 'Trash')";
 } else {
  $owner_id = $po_user['id'];
  $folder_id = $po_user['trash_folder'];
 }

pg_query($database, "begin");

$photos_in_trash = pg_query($database, "
  select path
    from photo, photo_version, files
   where files.version = photo_version.identifier
     and photo.identifier = photo_version.photo
     and photo.folder = $folder_id");

$num_of_photos_in_trash = pg_num_rows($photos_in_trash);

$result = TRUE;

// We need to check to see if we're erasing our watermark photo!
if ($po_options['watermark_photo']) {
  $result = pg_query($database, "select identifier from photo_version where photo in (select identifier from photo where folder=$folder_id and identifier = $po_options[watermark_photo])");
  if (pg_num_rows($result) > 0) {
    $result = store_user_pref($database, $po_user['id'], 'watermark_photo', '');
    $result = store_user_pref($database, $po_user['id'], 'watermark_path', '');
  }		     
 }

if ($result) {
  // remove references in keywords 
  $result = pg_query($database, "delete from photo_keywords where photo in (select identifier from photo where folder=$folder_id)");
 }

if ($result) {
  // remove references in albums
  $result = pg_query($database, "delete from album_content where photo in (select identifier from photo where folder=$folder_id)");
 }

if ($result) {
  // remove all photo_dupe entries 
  $result = pg_query($database, "delete from photo_dupe where photo in (select identifier from photo where folder=$folder_id)");
 }

if ($result) {
  // remove all file entries
  $result = pg_query($database, "delete from files where version in (select identifier from photo_version v where v.photo in(select identifier from photo p where p.folder=$folder_id))");
 }

if ($result) {
  // remove all photo_version entries 
  $result = pg_query($database, "delete from photo_version where photo in (select identifier from photo where folder=$folder_id)");
 }

if ($result) {
  // remove all photo_tech entries
  $result = pg_query($database, "delete from photo_tech where photo in (select identifier from photo where folder=$folder_id)");
}

if ($result) {
  // remove all ratings
  $result = pg_query($database, "delete from rating where photo in (select identifier from photo where folder=$folder_id)");
 }

if ($result) {
  // now remove the actual photo entries
  $result = pg_query($database, "delete from photo where folder=$folder_id");
 }

if (!$result) {
  site_push_error($strings['errors']['db_insert_failed']);
  pg_query($database, "rollback");
  site_epilog($database);
  header("Location: user.php?user=$owner_id");
  exit();
}

// Lastly, remove all of the thumbnail and image from the filesystem
$err = error_reporting(0);
for ($i=0; $i < $num_of_photos_in_trash; $i++) {
  $drop_this_image = pg_fetch_row($photos_in_trash, $i);
  unlink($image_repository_path . "/" .$drop_this_image[0]);
  /* if a content based search server is set up, audit the removed images */
  // audit_photo($database, $drop_this_image[3]);
}
error_reporting($err);

pg_query($database, "commit");

site_epilog($database);
header("Location: user.php?user=$owner_id");
?>
